var Est25000_produtos_processados_Controller = function(General, ScreenService, templateManager, ZHPromise, EstUtil, restEngine){
    
    this.openForm = function(widget){
        let widgetGridPrincipal = widget;
        let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado');
        let widgetGrid   = templateManager.container.getWidget('gridFilhaProdutoProcessado');
        widgetTabbed.currentRow = widgetGridPrincipal.currentRow;
        let fieldDsconv = widgetTabbed.getField('DSCONVERCAO');
        let fieldPropQuant = widgetGrid.getField('VRPROPQUANTIDADE');
        let dsSGUNID = widget.currentRow.SGUNIDADE? widget.currentRow.SGUNIDADE : '';
        let dsSGUNIDESTO = widget.currentRow.SGUNIDADEPESTO? widget.currentRow.SGUNIDADEPESTO : '';
        fieldDsconv.label = 'Fator Conversão ' + dsSGUNID + ' para ' + dsSGUNIDESTO;
        fieldPropQuant.label = 'Proporção ' + dsSGUNIDESTO;
        widget.currentRow.DSCONVERCAO = widget.currentRow.VRFATOCONV;
        ScreenService.openSwipe(widgetTabbed);
    };
    
    this.produtoProcessadoOnChange = function(args){
    	let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado'); 
    	let widgetGrid   = templateManager.container.getWidget('gridFilhaProdutoProcessado');
    	let fieldDsconv = widgetTabbed.getField('DSCONVERCAO');
        let fieldPropQuant = widgetGrid.getField('VRPROPQUANTIDADE');
    	let dsSGUNID = widgetTabbed.currentRow.SGUNIDADE? widgetTabbed.currentRow.SGUNIDADE : '';
        let dsSGUNIDESTO = widgetTabbed.currentRow.SGUNIDADEPESTO? widgetTabbed.currentRow.SGUNIDADEPESTO : '';
        fieldDsconv.label = 'Fator Conversão ' + dsSGUNID + ' para ' + dsSGUNIDESTO;
        fieldPropQuant.label = 'Proporção ' + dsSGUNIDESTO;
        widgetTabbed.currentRow.DSCONVERCAO = widgetTabbed.currentRow.VRFATOCONV;
    };
    
    this.openCloseForm = function(){
        let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado');
        
        // solução paliativa para exibição de Swipe sem formatação
        ScreenService.openSwipe(widgetTabbed).then(opened => {
        	setTimeout(function() {
        		ScreenService.goBack();
        	}, 1000);
        });
    };
    
    this.newProdutoProcessado = function(widget){
        let widgetGridPrincipal = widget;
        widgetGridPrincipal.dataSource.newRow();
        let arrayWidgetGridPrincipal = widgetGridPrincipal.dataSource.data;
        let nextCurrentRow = arrayWidgetGridPrincipal[arrayWidgetGridPrincipal.length-1];
        widgetGridPrincipal.currentRow = nextCurrentRow;
        this.openForm(widgetGridPrincipal);
    };
    
    this.rulezToReadOnlyTabbedFields = function(){
        let widgetGridPrincipal = templateManager.container.getWidget('gridPaiProdutoProcessado');
        let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado');
        if(widgetGridPrincipal.currentRow.__is_new){
            widgetTabbed.getField('NMPRODUTO').readOnly = false;
            widgetTabbed.getField('DSPRODPROCESSA').readOnly = false;
        }else{
            widgetTabbed.getField('NMPRODUTO').readOnly = true;
            widgetTabbed.getField('DSPRODPROCESSA').readOnly = false;
        }
    };
    
    this.popNewRowOnCancel = function(args){
        let widgetGridPrincipal = templateManager.container.getWidget('gridPaiProdutoProcessado');
        let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado');
        
        if(widgetGridPrincipal.currentRow.__is_new){
            widgetGridPrincipal.dataSource.data.pop();
        }
        
        /*let widget = args.owner.widget;
        if( widget.mode == 'view' || widget.mode == 'list'){
            ScreenService.goBack();
        }else{
            General.backOrCancel(args);
        }*/
        
    };
    
    this.cancelGrid = function(args){
		var deferred = ZHPromise.defer();
		if (args.row.__is_new) {
			args.owner.widget.list(false);
			args.owner.widget.dataSource.data.pop();
			args.owner.widget.currentRow = {};
			deferred.resolve();
		} else if (args.owner.widget.mode === 'edit') {
			args.owner.widget.view();
			for (var i in args.owner.widget.backupRow) {
				args.owner.widget.currentRow[i] = args.owner.widget.backupRow[i];
			}
			deferred.resolve();
			return deferred.promise;
		}else{
			deferred.resolve();
		}

		return deferred.promise;
	};
	
	this.cancelarGrid = function(args){
		let widgetFakeToEdit = templateManager.container.getWidget('wid_toEdit');
		let widgetFilha = templateManager.container.getWidget('gridFilhaProdutoProcessado');
		let widgetGrid = args.owner.widget;
		this.cancelGrid(args).then(()=>{
			widgetFakeToEdit.view();
			widgetFilha.list();
			if(widgetGrid.getParent().currentRow.__is_new)
				widgetGrid.dataSource.data.pop();
		});
	};
	
	this.newItprodprocessa = function(args){
	    let widgetItprodprocessa = templateManager.container.getWidget('gridFilhaProdutoProcessado');
	    let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado');
	    
	    widgetItprodprocessa.newRow();
	};
	
	this.saveItprodprocessa = function(args){
	    var promFirstSave = ZHPromise.defer();
	    let widgetGridPrincipal = templateManager.container.getWidget('gridPaiProdutoProcessado');
	    let widgetItprodprocessa = templateManager.container.getWidget('gridFilhaProdutoProcessado');
	    let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado');
	    let widgetFakeToEdit = templateManager.container.getWidget('wid_toEdit');
	    widgetItprodprocessa.currentRow.CDPRODUTO = widgetTabbed.currentRow.CDPRODUTO;
	    if(widgetGridPrincipal.currentRow.__is_new || widgetGridPrincipal.currentRow.changed){
	        if(widgetGridPrincipal.isValid() && widgetItprodprocessa.isValid()){
	        	if(widgetGridPrincipal.currentRow.__is_new == undefined){
					widgetGridPrincipal.currentRow.__is_new = false;
	    		}
	            EstUtil.saveCrud(widgetGridPrincipal, false, 'list').then(saved => {
	                widgetGridPrincipal.currentRow.__is_new = false;
	                promFirstSave.resolve();
	                widgetItprodprocessa.activate();
	            }, error => {
	                promFirstSave.reject();
	            }
				);
	        }else{
	        	widgetFakeToEdit.list();
	            return;
	        }
	    }else{
	    	if(widgetTabbed.currentRow.changed){
	    		EstUtil.saveCrud(widgetTabbed, false, 'list').then(saved =>{
	        		promFirstSave.resolve();
	    		});
	    	}else{
	    		promFirstSave.resolve();
	    	}
	    }
	    if(widgetItprodprocessa.currentRow.__is_new || widgetItprodprocessa.currentRow.changed){
		    if(widgetItprodprocessa.isValid()){
		        let row = widgetItprodprocessa.currentRow;
		        row.VRPROPVALOR = row.VRPROPVALOR_inline || row.VRPROPVALOR;
		        row.VRPROPVALOR = EstUtil.parseStrToFloat(row.VRPROPVALOR);   
		        promFirstSave.then(()=>{
		            EstUtil.saveCrud(widgetItprodprocessa, false, 'list').then(saved =>{
		            	widgetItprodprocessa.currentRow = {};
		            });
		        });
		    }
	    }
	};
	
	this.unckeckOldCheckboxes = function(args){
		let widget = args.owner;
		widget.dataSource.clearCheckedRows();
	};
	
	this.saveInlineItprodprocessa = function(){
        let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado');
		let widgetItprodprocessa = templateManager.container.getWidget('gridFilhaProdutoProcessado');
		var dataSet = widgetItprodprocessa.dataSource.data;
            
        dataSet = dataSet.filter(function(row){
            return row.changed === true && (!row.__is_new || EstUtil.rowEditedInline(row));
        });
        
        dataSet = EstUtil.fixInlineEditDataSet(dataSet);
        
        //parseFloat
        dataSet.forEach(row =>{
        	row.VRPROPVALOR = EstUtil.parseStrToFloat(row.VRPROPVALOR);
        	if(row.changed_VRPROPVALOR)
        		row.changed_VRPROPVALOR = EstUtil.parseStrToFloat(row.VRPROPVALOR);
        });
        
        
        EstUtil.saveDataSetCrud(dataSet, 'itprodprocessa').then(saved =>{
        	widgetItprodprocessa.list();
        	EstUtil.cancelInlineEdit(widgetItprodprocessa);
        }, failed => {
        	ScreenService.showMessage(failed.error);
        });
        
        if(widgetTabbed.currentRow.changed)
        	widgetTabbed.saveRow();
        
        EstUtil.cancelInlineEdit(widgetItprodprocessa);
        
	};
	
	this.updateItprodGrid = function(){
		let widgetItprodprocessa = templateManager.container.getWidget('gridFilhaProdutoProcessado');
		if(widgetItprodprocessa.dataSource.data.length > 0)
			widgetItprodprocessa.reload();
	};
	
	this.enterEditionMode = function(args){
		let activeWidget = templateManager.container.getActiveWidget();
		let widgetTabbed = templateManager.container.getWidget('tabbedProdutoProcessado');
		let widgetItprodprocessa = templateManager.container.getWidget('gridFilhaProdutoProcessado');
		let widgetFakeToEdit = templateManager.container.getWidget('wid_toEdit');
		
		let onEdit = ['inline_edit', 'edit'];
		if(!onEdit.includes(activeWidget.mode) && widgetTabbed.currentRow.__is_new == false){
			widgetFakeToEdit.edit();
		}
	};
    
};

Configuration(function (ContextRegister){
    ContextRegister.register('Est25000_produtos_processados_Controller', Est25000_produtos_processados_Controller);
});
