var Est51000_ParametrosImportacaoEstoque_Controller = function(General, ScreenService, templateManager){
     var mensagens = {
        unidadeNaoControlaEstoque: 'A unidade selcionada não controla estoque.',
        editErro: 'Selecione uma filial antes de editar.'
    };
    
    this.validaFilial = function(widget) {
        if(widget.currentRow.NMFILIAL) {
            var filter = [
                {
                    "name":"CDFILIAL",
                    "operator":"=",
                    "value": widget.currentRow.CDFILIAL
                }
            ];
            General.callRestEngine('est#/crud/paramfilial', 'FilterData', filter).then(function(success){
                var paramfilial = success.dataset.paramfilial[0];
                if(paramfilial.IDCTRLESTQ === 'N'){
                    widget.currentRow.CDFILIAL = '';
                    widget.currentRow.NMFILIAL = '';
                    ScreenService.showMessage(mensagens.unidadeNaoControlaEstoque); 
                }
                else{
                    this.changeReadOnly(templateManager.container.getWidget('widgetParams'), paramfilial);
                }
            }.bind(this));
            
        }
        else templateManager.container.getWidget('widgetParams').reload();
    };
    
    this.changeReadOnly = function(widget, paramfilial) {
        widget.getField('QTTAMALMOX').readOnly   = this.getReadOnlyByParam(paramfilial.IDUTILALMOX);
        widget.getField('QTTAMLOCAL').readOnly   = this.getReadOnlyByParam(paramfilial.IDUTILLCESTQ);
        widget.getField('QTTAMLOTE').readOnly    = this.getReadOnlyByParam(paramfilial.IDUTILLOTE);
        widget.getField('QTTAMSUBLOTE').readOnly = this.getReadOnlyByParam(paramfilial.IDUTILLOTE);
        
        if(widget.getField('QTTAMLOTE').readOnly)
            widget.getField('QTTAMLOTE').validations = {};
        else
            widget.getField('QTTAMLOTE').validations = {"max": {"value": "20"}};
        
        if(widget.getField('QTTAMSUBLOTE').readOnly)
            widget.getField('QTTAMSUBLOTE').validations = {};
        else
            widget.getField('QTTAMSUBLOTE').validations = {"max": {"value": "4"}};
            
        widget.reload();
    };
    
    this.getReadOnlyByParam = function(param) {
        if(param === 'S') return false;
        else return true;
    };
    
    this.setReadOnlyCodBarra = function(field) {
        if(field.value() === 'B') {
            templateManager.container.getWidget('widgetParams').getField('QTTAMCDBARRA').readOnly = false;
        }
        else {
            templateManager.container.getWidget('widgetParams').getField('QTTAMCDBARRA').readOnly = true;
            templateManager.container.getWidget('widgetParams').currentRow.QTTAMCDBARRA = '';
        }
    };
    
    this.setFormCurrentRow = function(widget) {
        if(widget.dataSource.data[0] === undefined && widget.getParent().currentRow.CDFILIAL) {
            widget.currentRow = {CDFILPARIMPEST: widget.getParent().currentRow.CDFILIAL, 
                                IDTIPOPRODPAR: 'C',
                                IDCONSQTDEST: 'N',
                                IDFILIPADIMPEST: 'N',
                                IDTPSEPARADOR: '2',
                                __is_new: true};
            General.saveCrud(widget).then(function(success){
                widget.reload();
            });
        }
        else if(!widget.getParent().currentRow.CDFILIAL){
            widget.currentRow = {OBSERVACAO: ScreenService.i18n('Observação: ao gerar um arquivo para ser importado, os campos deverão obedecer ao layout definido, o que inclui o tamanho do campo aqui parametrizado. Caso o registro possua tamanho inferior ao definido, este deverá ser ajustado com zeros à esquerda no caso de quantidade ou com espaços à esquerda para os demais campos, até atingir o tamanho estipulado.')};  
        }    
        else{
            widget.currentRow = widget.dataSource.data[0];
            this.setObservacao(widget);
            widget.currentRow.__is_new = false;
        }
    };
    
    this.setObservacao = function(widget) {
        widget.currentRow.OBSERVACAO = ScreenService.i18n('Observação: ao gerar um arquivo para ser importado, os campos deverão obedecer ao layout definido, o que inclui o tamanho do campo aqui parametrizado. Caso o registro possua tamanho inferior ao definido, este deverá ser ajustado com zeros à esquerda no caso de quantidade ou com espaços à esquerda para os demais campos, até atingir o tamanho estipulado.'); 
    };
    
    this.validaQtMaxima = function(widget) {
        if(widget.currentRow.QTNUMEROINT > 10 || widget.currentRow.QTNUMERODEC > 10) {
            ScreenService.showMessage('A Faixa permitida é de 1 a 10.');
            widget.currentRow.QTNUMEROINT = widget.backupRow.QTNUMEROINT;
            widget.currentRow.QTNUMERODEC = widget.backupRow.QTNUMERODEC;
        }
    };
    
    this.edit = function(widget) {
        if(!widget.currentRow.CDFILPARIMPEST) ScreenService.showMessage(mensagens.editErro);  
        else General.widgetEdit(widget);
    };
    
    this.save = function(widget) {
        General.saveCrud(widget).then(function(success){
            widget.template = 'widget/form-view.html';  
            widget.list();
            widget.reload();
        }); 
    };
    
    this.cancel = function(args) {
        General.backOrCancel(args).then(function(success) {
            var widget = args.owner.widget;
            widget.template = 'widget/form-view.html';  
            widget.list();
            widget.reload();
        }); 
        
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('Est51000_ParametrosImportacaoEstoque_Controller', Est51000_ParametrosImportacaoEstoque_Controller);
});
