var Est56000_EstoqueMinimoProdutos_Controller = function(ScreenService, General, templateManager, ZhFilterPreferences){
    var mensagens = {
        tempoMedio: 'O tempo médio de reposição deve estar entre 0 e 999.',
        unidadeNaoControlaEstoque: 'A unidade selcionada não controla estoque.',
        unidadeNaoControlaAlmox: 'Atenção, está unidade não controla almoxarifado.'
    };
    
    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        });
    };
    
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
	
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };

    
    
    this.validaFilial = function(widget) {
        if(widget.currentRow.CDFILIAL) {
            var filter = [
                {
                    "name":"CDFILIAL",
                    "operator":"=",
                    "value": widget.currentRow.CDFILIAL
                }
            ];
            General.callRestEngine('est#/crud/paramfilial', 'FilterData', filter).then(function(success){
                if(success.dataset.paramfilial[0].IDCTRLESTQ ==='N'){
                    widget.currentRow.CDFILIAL = '';
                    widget.currentRow.NMFILIAL = '';
                    ScreenService.showMessage(mensagens.unidadeNaoControlaEstoque); 
                }
                else {
                    //Valida controle de almoxarifado.
                    if(success.dataset.paramfilial[0].IDUTILALMOX === 'N') {
                        ScreenService.showMessage(mensagens.unidadeNaoControlaAlmox); 
                        templateManager.container.getWidget('widgetProdutoAlmox').enabled = false;
                        templateManager.container.getWidget('tabbed').currentRow = {DSALMOXARIFE: '', CDALMOXARIFE: ''};
                        templateManager.container.getWidget('tabbed').getField('DSALMOXARIFE').readOnly = true;
                        templateManager.container.getWidget('widgetProdutoAlmox').reload();
                    }
                    else {
                        templateManager.container.getWidget('widgetProdutoAlmox').enabled = true;
                        templateManager.container.getWidget('tabbed').getField('DSALMOXARIFE').readOnly = false;
                        templateManager.container.getWidget('tabbed').currentRow = {DSALMOXARIFE: '', CDALMOXARIFE: ''};
                    }
                }
            });
        }
        else {
            templateManager.container.getWidget('tabbed').currentRow = {DSALMOXARIFE: '', CDALMOXARIFE: ''};
            templateManager.container.getWidget('widgetProdutoAlmox').enabled = true;
            templateManager.container.getWidget('widgetProdutoAlmox').reload();
        }
    };
    
    this.verificaTempoMedio = function(widget) {
        if(widget.currentRow.NRTEMPREPEST && 
        (widget.currentRow.NRTEMPREPEST > 999 || widget.currentRow.NRTEMPREPEST < 0))  {
            ScreenService.showMessage(mensagens.tempoMedio);
            widget.currentRow.NRTEMPREPEST = '';
        }
    };
    this.saveInlineEdit = function(widget) {
        var rows = widget.dataSource.data;
        rows = rows.filter(function(row){
            return row.changed === true && !row.__is_new;
        });
        rows.forEach(function(row) {
            var rowItem = row;
            rowItem.QTESTOQMIN = rowItem.QTESTOQMIN_inline || rowItem.QTESTOQMIN;
            rowItem.QTESTMINSAID = rowItem.QTESTMINSAID_inline || rowItem.QTESTMINSAID;
            rowItem.NRTEMPREPEST = rowItem.NRTEMPREPEST_inline || rowItem.NRTEMPREPEST;
            General.callRestEngine('est#/saveEstqMinProd', 'Row', row).then(function(success){
                widget.reload();
                
            },
            function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                        widget.reload();
                    }
                }
            );
            
        });
        widget.list();
    };
    
    this.saveInlineEditAlmox = function(widget) {
        var rows = widget.dataSource.data;
        rows = rows.filter(function(row){
            return row.changed === true && !row.__is_new;
        });
        rows.forEach(function(row) {
            var rowItem = row;
            rowItem.CDALMOXARIFE = row.CDALMOXARIFE || widget.appliedFilter.FILTER_ROW.CDALMOXARIFE;
            rowItem.QTMINPRODALMOX = rowItem.QTMINPRODALMOX_inline || rowItem.QTMINPRODALMOX;
            General.callRestEngine('est#/saveEstqMinProdAlmox', 'Row', row).then(function(success){
                widget.reload();
            },
            function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                        widget.reload();
                    }
                }
            );
            
        });
        widget.list();
    };
    
    this.setFilial = function() {
        if(templateManager.container) {
            var container = templateManager.container;
            var cdfilial = container.getWidget('widgetProduto').appliedFilter.FILTER_ROW.CDFILIAL;
            container.getWidget('widgetProdutoAlmox').dataSourceFilter[0].value = cdfilial;
            container.getWidget('tabbed').getField('DSALMOXARIFE').dataSourceFilter[0].value = cdfilial;
        }
    };
    
};

Configuration(function (ContextRegister){
    ContextRegister.register('Est56000_EstoqueMinimoProdutos_Controller', Est56000_EstoqueMinimoProdutos_Controller);
});
