var Est57000_TransferenciaEstoque_Controller = function(ScreenService, General, templateManager, Est57000_TransferenciaEstoque_Service, Lib00206_InfComplProduto_Controller, Est58000_RetiradaEstoque_Service, ValidacoesEstoque_Service, ZHPromise, ZhFilterPreferences, MessageService,EstUtil) {
    var mensagens = {
        produtoIncompleto: 'Não é possivel salvar pois faltam informações para o produto ',
        unidadeNEstoque: 'Unidade não controla estoque.',
        unidadeNAlmox: 'Unidade não controla almoxarifado.',
        naoPossuiFiltro: "É necessario realizar o filtro primeiro"
    };

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var defaultFilter = widget.dataSourceFilter;
        this.getFilialLogada().then(function(success) {
            var filialLogada = success.dataset.filial[0];
            defaultFilter.CDFILIAL = filialLogada.CDFILIAL;
            defaultFilter.NMFILIAL = filialLogada.NMFILIAL;
            ZhFilterPreferences.setOriginalFilter(widget.id, defaultFilter);
            ZhFilterPreferences.openFilterWidget(widget, defaultFilter).then(function() {
                let filtro = templateManager.container.getActiveWidget();
                this.getParamFilial(filtro, true);
            }.bind(this));
        }.bind(this));
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };

    this.onChangeUnidade = function(widget, atualizaDataLancamento) {

        this.apagaValorAlmoxarifadoLocalizacao(widget, 'P_CDALMOXORIG', 'DSALMOXSAID');
        this.apagaValorAlmoxarifadoLocalizacao(widget, 'P_CDLOCALORIG', 'DSLOCALSAID');
        this.apagaValorAlmoxarifadoLocalizacao(widget, 'P_CDALMOXDEST', 'DSALMOXENTR');
        this.apagaValorAlmoxarifadoLocalizacao(widget, 'P_CDLOCALDEST', 'DSLOCALENTR');
        this.controlaUtilizacaoAlmoxarifadoLocalizacao(widget, widget.currentRow.IDUTILALMOX, widget.currentRow.IDUTILLCESTQ, widget.currentRow.IDCTRLESTQ);
        
        if (widget.currentRow.IDCTRLESTQ == 'N') {
            ScreenService.showMessage(mensagens.unidadeNEstoque);
            widget.currentRow.CDFILIAL = '';
            widget.currentRow.NMFILIAL = '';
            widget.getField('DTMOVIESTQ').value({ start: '', end: '' });
        }
        else {
            if (widget.currentRow.IDUTILALMOX == 'N') {
                ScreenService.showMessage(mensagens.unidadeNAlmox);
                widget.currentRow.CDFILIAL = '';
                widget.currentRow.NMFILIAL = '';
                widget.getField('DTMOVIESTQ').value({ start: '', end: '' });
            }
            else if (atualizaDataLancamento) {
                this.buscaDataProcessamentoFilial(widget);
            }
        }

        if (widget.currentRow.CDFILIAL) {
            widget.getField('DSALMOXENTR').dataSourceFilter.forEach(function(fil) {
                if (fil.name === 'CDFILIAL') {
                    fil.value = widget.currentRow.CDFILIAL;
                }
            });

            widget.getField('DSLOCALENTR').dataSourceFilter.forEach(function(fil) {
                if (fil.name === 'CDFILIAL') {
                    fil.value = widget.currentRow.CDFILIAL;
                }
            });

            widget.getField('DSALMOXSAID').dataSourceFilter.forEach(function(fil) {
                if (fil.name === 'CDFILIAL') {
                    fil.value = widget.currentRow.CDFILIAL;
                }
            });

            widget.getField('DSLOCALSAID').dataSourceFilter.forEach(function(fil) {
                if (fil.name === 'CDFILIAL') {
                    fil.value = widget.currentRow.CDFILIAL;
                }
            });

            widget.getField('NRREQUESTO').dataSourceFilter.forEach(function(fil) {
                if (fil.name === 'CDFILIAL') {
                    fil.value = widget.currentRow.CDFILIAL;
                }
            });

            templateManager.container.getWidget('gridProdutosTransferencia').getField('NMPRODUTO').dataSourceFilter.forEach(function(fil) {
                if (fil.name === 'CDFILIAL') {
                    fil.value = widget.currentRow.CDFILIAL;
                }
            });

            widget.getField('DSALMOXENTR').reload();
            widget.getField('DSLOCALENTR').reload();
            widget.getField('DSALMOXSAID').reload();
            widget.getField('DSLOCALSAID').reload();
            widget.getField('NRREQUESTO').reload();
            templateManager.container.getWidget('gridProdutosTransferencia').getField('NMPRODUTO').reload();
        }


    };

    this.getParamFilial = function(widget, isFilter) {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": widget.currentRow.CDFILIAL
        }];
        General.callRestEngine('est#/crud/paramfilial', 'FilterData', filter).then(function(success) {
            var dataset = success.dataset.paramfilial[0];
            widget.currentRow.IDCTRLESTQ = dataset.IDCTRLESTQ;
            widget.currentRow.IDUTILALMOX = dataset.IDUTILALMOX;
            widget.currentRow.IDUTILLCESTQ = dataset.IDUTILLCESTQ;
            widget.currentRow.IDUTCTRLLOTE = dataset.IDUTCTRLLOTE;
            if (isFilter === true) {
                this.onChangeUnidade(widget, true);
            }
        }.bind(this));
    };

    this.verficaProdutoControlaEstoque = function(widget) {
        if (widget.currentRow.CDARVPROD) {
            if (widget.currentRow.IDPRODATIV == 'A') {
                if (widget.currentRow.IDUTCTRLLOTE && templateManager.container.getWidget('gridTransferencia').appliedFilter.FILTER_ROW.IDUTILLOTE) {
                    widget.currentRow.NRLOTEESTQ = '';
                    widget.getField('NRLOTEESTQ').readOnly = false;
                }
                if (widget.currentRow.IDCNTRESTOQ == 'N') {
                    widget.currentRow.CDARVPROD = null;
                    widget.currentRow.NMPRODUTO = null;
                    widget.currentRow.SGUNIDADE = null;
                    ScreenService.showMessage('Produto não controla estoque.');
                }
                else {
                    if (widget.currentRow.$error) {
                        delete(widget.currentRow.$error);
                    }
                    widget.getField('QTTOTLANCTO').readOnly = true;
                    widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
                    widget.currentRow.CDFILIMOVI = widget.getParent().currentRow.CDFILIMOVI;
                    Lib00206_InfComplProduto_Controller.infComplementares(widget, widget.currentRow);
                    widget.currentRow.QTTOTLANCTO = null;
                }

            }
            else {
                widget.currentRow.CDARVPROD = null;
                widget.currentRow.NMPRODUTO = null;
                widget.currentRow.SGUNIDADE = null;
                ScreenService.showMessage('O produto encontra-se inativo para a filial.');
            }
        }
    };

    this.atualizaMaxQuantidade = function(widget) {
        widget.currentRow.IDQUANTID = 'S';
        var gridTransferencia = templateManager.container.getWidget('gridTransferencia');
            var result = 0;
            if (widget.currentRow.QTESTOQDIA) {
                result = widget.currentRow.QTESTOQDIA;
            }

            if (gridTransferencia.mode == 'edit') {
                if (widget.getParent().currentRow.NRREQUESTO) {
                    if (widget.currentRow.QTREQUESTO) {
                        if (widget.currentRow.QTREQUESTO > result) {
                            widget.currentRow.QTTOTLANCTO = result;
                        }
                        else {
                            widget.currentRow.QTTOTLANCTO = widget.currentRow.QTREQUESTO;
                        }
                    }
                }
            }
            var mensagem = "Posição Estoque: ".concat(result);
            widget.getField('QTTOTLANCTO').validations.max = { "value": result, "message": mensagem };

    };

    this.apagaValoresLote = function(widget) {
        widget.currentRow.NRLOTEESTQ = null;
        widget.currentRow.NRSUBLOTE = null;
    };

    this.newRowProduto = function(widget) {
        var gridTransferencia = templateManager.container.getWidget('gridTransferencia');
        if (gridTransferencia.mode == 'edit') {
            if (widget.getParent().currentRow.NRREQUESTO) {
                if (!widget.currentRow.NRREQUESTO) {
                    widget.getField('NMPRODUTO').readOnly = false;
                    widget.getField('QTTOTLANCTO').readOnly = true;
                }
            }
        }
        else {
            widget.getField('NMPRODUTO').readOnly = false;
            widget.getField('QTTOTLANCTO').readOnly = true;
        }
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        widget.currentRow.CDFILIMOVI = widget.getParent().currentRow.CDFILIMOVI;
        if(widget.getParent().currentRow.CDALMOXSAID)
            widget.currentRow.CDALMOXARIFE = widget.getParent().currentRow.CDALMOXSAID;
        if(widget.getParent().currentRow.CDLCESTSAID)
            widget.currentRow.CDLOCALESTOQ = widget.getParent().currentRow.CDLCESTSAID;
    };

    this.apagaValorAlmoxarifadoLocalizacao = function(widget, codigo, nome) {
        widget.currentRow[codigo] = '';
        widget.currentRow[nome] = '';
    };

    //realiza controle para não permirir almoxarifado e localização  de origem igual ao de destino
    this.controlaValoresDestinoOrigem = function(field, tipo, campoAtual, campoDestino) {
        var widget;
        var filtro;

        if (field.widget.name == 'zhFilterPreferencesSelectConditions') {
            widget = templateManager.container.getWidget('gridTransferencia');
            filtro = field.widget.currentRow;
        }
        else {
            widget = field.widget;
            filtro = field.widget.appliedFilter.FILTER_ROW;
        }

        if (tipo == 'Almoxarifado') {
            if (field.value()) {
                // se a unidade controla localização, o almoxarifado de origem pode ser igual ao de destino
                if (filtro.IDUTILLCESTQ == 'N') {
                    if (field.widget.currentRow[campoAtual] == field.widget.currentRow[campoDestino]) {
                        ScreenService.showMessage('Almoxarifado de origem igual ao Almoxarifado de destino.');
                        field.value('');
                        field.widget.currentRow[campoAtual] = '';
                    }
                }
            }
        }
        else if ('Loacalização') {
            if (field.value()) {
                if (field.widget.currentRow[campoAtual] == field.widget.currentRow[campoDestino]) {
                    ScreenService.showMessage('Loacalização de origem igual a Localização de destino.');
                    field.value('');
                    field.widget.currentRow[campoAtual] = '';
                }
            }
        }
    };

    this.fieldIsSet = function(fieldValue) {
        if (fieldValue) return true;
        else return false;
    };

    // habilita/desabilita campos de localização de almoxarifado
    this.habilitaLocalAlmoxarifado = function(widget, campo, isFilter) {
        var row = widget.currentRow;
        var almoxarifadoIsSet = false;
        if (campo == 'DSALMOXSAID' && row.IDUTILLCESTQ == 'S') {
            almoxarifadoIsSet = this.fieldIsSet(row.DSALMOXSAID);
            widget.getField('DSLOCALSAID').readOnly = !almoxarifadoIsSet;
            widget.getField('DSLOCALSAID').readOnlyOnEdit = !almoxarifadoIsSet;
            widget.getField('DSLOCALSAID').reload();

        }
        else if (campo == 'DSALMOXENTR' && row.IDUTILLCESTQ == 'S') {
            almoxarifadoIsSet = this.fieldIsSet(row.DSALMOXENTR);
            widget.getField('DSLOCALENTR').readOnly = !almoxarifadoIsSet;
            widget.getField('DSLOCALENTR').readOnlyOnEdit = !almoxarifadoIsSet;
            widget.getField('DSLOCALENTR').reload();

        }
    };

    this.getFieldValueFilter = function(filedName, widgetName) {
        var container = templateManager.container;
        if (container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if (filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if (f) {
                    filterWidget = container.getWidget(widgetName).appliedFilter;
                }

            }

            if (filterWidget) {
                var valueField;
                if (filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[filedName];
                else
                    valueField = filterWidget.FILTER_ROW[filedName];

                return valueField || null;
            }
            else return null;
        }
        else return null;
    };

    this.controlaUtilizacaoAlmoxarifadoLocalizacao = function(widget, controlaAlmoxarifado, controlaLocal, controlaEstoque) {
        var utilizaAlmoxarifado = controlaAlmoxarifado || 'N';
        var utilizaLocalizacao = controlaLocal || 'N';
        var utilizaEstoque = controlaEstoque || 'N';

        if (utilizaEstoque == 'S') {
            if (utilizaAlmoxarifado == 'S') {
                if (utilizaLocalizacao == 'S') {
                    widget.getField('DSALMOXSAID').readOnly = false;
                    widget.getField('DSALMOXENTR').readOnly = false;

                    widget.getField('DSLOCALSAID').readOnly = false;
                    widget.getField('DSLOCALENTR').readOnly = false;
                }
                else {
                    widget.getField('DSALMOXSAID').readOnly = false;
                    widget.getField('DSALMOXENTR').readOnly = false;

                    widget.getField('DSLOCALSAID').readOnly = true;
                    widget.getField('DSLOCALENTR').readOnly = true;

                }
            }
            else {
                widget.getField('DSALMOXSAID').readOnly = true;
                widget.getField('DSALMOXENTR').readOnly = true;

                widget.getField('DSLOCALSAID').readOnly = true;
                widget.getField('DSLOCALENTR').readOnly = true;
            }
            if (widget.name == 'gridTransferencia') {
                this.controlaObrigatoriedadeAlmoxarifadoLocalizacao(widget, controlaAlmoxarifado, controlaLocal, controlaEstoque);
            }
        }
        else {
            widget.getField('DSALMOXSAID').readOnly = true;
            widget.getField('DSALMOXENTR').readOnly = true;
            widget.getField('DSLOCALSAID').readOnly = true;
            widget.getField('DSLOCALENTR').readOnly = true;
            if (widget.name == 'gridTransferencia') {
                this.controlaObrigatoriedadeAlmoxarifadoLocalizacao(widget, controlaAlmoxarifado, controlaLocal, controlaEstoque);
            }
        }
    };

    this.controlaObrigatoriedadeAlmoxarifadoLocalizacao = function(widget, controlaAlmoxarifado, controlaLocal, controlaEstoque) {
        var utilizaAlmoxarifado = controlaAlmoxarifado || 'N';
        var utilizaLocalizacao = controlaLocal || 'N';
        var utilizaEstoque = controlaEstoque || 'N';

        if (utilizaEstoque == 'S') {
            if (utilizaAlmoxarifado == 'S') {
                if (utilizaLocalizacao == 'S') {
                    widget.getField('DSALMOXSAID').validations.required = true;
                    widget.getField('DSALMOXENTR').validations.required = true;

                    widget.getField('DSLOCALSAID').validations.required = true;
                    widget.getField('DSLOCALENTR').validations.required = true;
                }
                else {
                    widget.getField('DSALMOXSAID').validations.required = true;
                    widget.getField('DSALMOXENTR').validations.required = true;

                    delete(widget.getField('DSLOCALSAID').validations.required);
                    delete(widget.getField('DSLOCALENTR').validations.required);

                }
            }
            else {
                delete(widget.getField('DSALMOXSAID').validations.required);
                delete(widget.getField('DSALMOXENTR').validations.required);

                delete(widget.getField('DSLOCALSAID').validations.required);
                delete(widget.getField('DSLOCALENTR').validations.required);

            }
        }
        else {
            delete(widget.getField('DSALMOXSAID').validations.required);
            delete(widget.getField('DSALMOXENTR').validations.required);

            delete(widget.getField('DSLOCALSAID').validations.required);
            delete(widget.getField('DSLOCALENTR').validations.required);
        }
    };

    this.recarrecarWidgetsFilhas = function(widget) {
        if (!widget.currentRow.__is_new) {
            widget.widgets.forEach(function(widg) {
                widg.reload();
            });
        }
    };

    this.recarregarDataField = function(field) {
        /*field.dataSourceFilter.forEach(function(fil){
           if(fil.name == 'CDFILIAL'){
               fil.value = field.widget.currentRow.CDFILIAL;
               field.reload();
           } 
        }); 
        */
        field.reload().then(
            function(Success) {
                if (field.dataSource.data.length == 0) {
                    self.mensagemDataVazio(field.name);
                }
            },
            function(callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    this.mensagemDataVazio = function(nomeField) {
        switch (nomeField) {
            case 'DSALMOXENTR':
                /* falls through */
            case 'DSALMOXSAID':
                ScreenService.showMessage('Não há almoxarifado cadastrado(a) para a unidade informada.');
                break;
            case 'DSLOCALENTR':
                /* falls through */
            case 'DSLOCALSAID':
                ScreenService.showMessage('Não há localização cadastrado(a) para o almoxarifado informado.');
                break;
        }
    };

    this.cancelTransferencia = function(args) {
        var widget = args.owner.widget;
        if (widget.actions[3].label === 'Adicionar Produtos') {
            this.changeHideInconLabelVisible(widget.actions, 'Salvar', false, 'salvar', true);
        }
        General.backOrCancel(args);
        templateManager.container.getWidget('gridTransferencia').enabled = true;
        this.controlaStatusWidgets(widget, 'gridTransferencia', true);
    };

    this.addTransferencia = function(widget) {
        this.changeHideInconLabelVisible(widget.actions, 'Adicionar Produtos', false, 'salvar', true);
        this.controlaStatusWidgets(widget, widget.name, false);
        if (widget.appliedFilter !== undefined) {
            var filtroPopup = widget.appliedFilter.FILTER_ROW;
            widget.newRow();
            widget.currentRow.CDLCESTENTR = ' ';
            widget.currentRow.CDLCESTSAID = ' ';
            widget.currentRow.CDALMOXSAID = ' ';
            widget.currentRow.CDALMOXENTR = ' ';
            this.controlaUtilizacaoAlmoxarifadoLocalizacao(widget, filtroPopup.IDUTILALMOX, filtroPopup.IDUTILLCESTQ, filtroPopup.IDCTRLESTQ);
            if (filtroPopup.CDFILIAL) {
                widget.currentRow.CDFILIMOVI = filtroPopup.CDFILIAL;
                widget.currentRow.CDFILIAL   = filtroPopup.CDFILIAL;
                widget.currentRow.NMFILIAL   = filtroPopup.NMFILIAL;
                
                Object.assign(widget.currentRow, filtroPopup);
                
                widget.getField('DSALMOXSAID').readOnly = !!filtroPopup.DSALMOXSAID;
                widget.getField('DSLOCALSAID').readOnly = !!filtroPopup.DSLOCALSAID;
                widget.getField('DSALMOXENTR').readOnly = !!filtroPopup.DSALMOXENTR;
                widget.getField('DSLOCALENTR').readOnly = !!filtroPopup.DSLOCALENTR;
                
                Est57000_TransferenciaEstoque_Service.buscaDataProcessamento(filtroPopup).then(
                    function(Success) {
                        var data = Success.dataset.dataProcessamento.DTPROCESSA;
                        widget.getField('DTMOVIESTQ').value(data);
                    },
                    function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                );
            }
        }
        else {
            ScreenService.showMessage(mensagens.naoPossuiFiltro);

        }
    };

    this.editTransferencia = function(widget) {
        this.controlaStatusWidgets(widget, widget.name, false);
        General.edit(widget);
        widget.getField('DSALMOXSAID').readOnly = true;
        widget.getField('DSALMOXENTR').readOnly = true;
        widget.getField('DSLOCALSAID').readOnly = true;
        widget.getField('DSLOCALENTR').readOnly = true;
        this.changeHideInconLabelVisible(widget.actions, "Salvar", true, "salvar", true);
    };

    this.cancelaItens = function(args) {
        var widget = args.owner.widget;
        var widgetItens = templateManager.container.getWidget('gridProdutosTransferencia');
        var gridTransferencia = templateManager.container.getWidget('gridTransferencia');
        if (gridTransferencia.mode == 'edit') {
            if (widget.getParent().currentRow.NRREQUESTO) {
                if (widget.currentRow.NRREQUESTO) {
                    args.row.__is_new = false;
                    General.backOrCancel(args);
                    args.row.__is_new = true;
                    this.changeHideInconLabelVisible(widgetItens.actions, 'Salvar', true, 'saveProdutos', true);
                }
                else {
                    widget.getField('NMPRODUTO').readOnly = true;
                    widgetItens.dataSource.data.pop();
                    ScreenService.goBack();
                }
            }
            else {
                General.backOrCancel(args);
                ScreenService.goBack();
                widget.reload();
            }
        }
        else {
            templateManager.container.getWidget('gridTransferencia').enabled = true;
            General.backOrCancel(args);
            ScreenService.goBack();
        }

    };
    
    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status) {
        mainWidget.widgets.forEach(function(widg) {
            if (nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if (mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };

    this.buscaDataProcessamentoFilial = function(widget) {
        if (widget.currentRow.CDFILIAL) {
            Est57000_TransferenciaEstoque_Service.buscaDataProcessamento(widget.currentRow).then(
                function(Success) {
                    var data = Success.dataset.dataProcessamento.DTPROCESSA;
                    var start = moment(data, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
                    var end = moment(data, 'DD/MM/YYYY').format('DD/MM/YYYY');
                    widget.getField('DTMOVIESTQ').value({ start: start, end: end });
                },
                function(callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
        else {
            widget.getField('DTMOVIESTQ').value({ start: '', end: '' });
        }
    };

    this.preparaParametosQueryTranferencia = function(widget) {
        var filtroPopupCurrentRow = widget.appliedFilter.FILTER_ROW;
        var filtro = [{
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filtroPopupCurrentRow.CDFILIAL
            },
            {
                "name": "P_DTLANCINI",
                "operator": "=",
                "value": filtroPopupCurrentRow.DTMOVIESTQ != null ? filtroPopupCurrentRow.DTMOVIESTQ.start : ""
            },
            {
                "name": "P_DTLANCFIN",
                "operator": "=",
                "value": filtroPopupCurrentRow.DTMOVIESTQ != null ? filtroPopupCurrentRow.DTMOVIESTQ.end : ""
            },
            {
                "name": "P_CDALMOXORIG",
                "operator": "=",
                "value": filtroPopupCurrentRow.P_CDALMOXORIG
            },
            {
                "name": "P_CDALMOXDEST",
                "operator": "=",
                "value": filtroPopupCurrentRow.P_CDALMOXDEST
            },
            {
                "name": "P_CDLOCALDEST",
                "operator": "=",
                "value": filtroPopupCurrentRow.P_CDLOCALDEST
            },
            {
                "name": "P_CDLOCALORIG",
                "operator": "=",
                "value": filtroPopupCurrentRow.P_CDLOCALORIG
            }
        ];
        // caso não informe a data o parâmetro P_DATA recebe 'T'
        if (!filtroPopupCurrentRow.DTMOVIESTQ.start) {
            filtro.push({
                "name": "P_DATA",
                "operator": "=",
                "value": 'T'
            });
        }
        else {
            filtro.push({
                "name": "P_DATA",
                "operator": "=",
                "value": ''
            });
        }
        widget.dataSourceFilter = filtro;
        widget.reload();
        if (!filtroPopupCurrentRow.IDUTILALMOX) {
            this.getParamFilial(filtroPopupCurrentRow);
        }
    };

    this.setaFiltroRequisicao = function(field) {
        var filtro = field.widget.appliedFilter.FILTER_ROW;
        field.dataSourceFilter[0].value = filtro.CDFILIAL;
        field.reload();
    };

    this.salvarTransferencia = function(widget) {

        if (widget.isValid()) {
            //save para nova transferência
            const widgetItens = templateManager.container.getWidget('gridProdutosTransferencia');

            if (widget.currentRow.__is_new) {
                    //caso seja selecionada alguma requisicao os produtos delas devem ser adicionado
                    if (widget.currentRow.NRREQUESTO) {
                        widget.enabled = false;
        				this.getItensOfRequisicao(widgetItens, widget.currentRow.CDFILIAL, widget.currentRow.NRREQUESTO);
        				this.focusAddProduto(widgetItens);
        				this.changeHideInconLabelVisible(widgetItens.actions, 'Voltar', true, 'voltarPagina', false);
        				this.changeHideInconLabelVisible(widgetItens.actions, 'Cancelar', true, 'cancelProdRequisicao', true);
        				this.controlButtonSaveAndImportVisibility(widgetItens);
                        widgetItens.getField('NMPRODUTO').readOnly = true;
                        widgetItens.getField('QTTOTLANCTO').readOnly = true;
                    }
                    //ativa a aba de produtos para selecionar o prdouto;
                    else {
                        widgetItens.enabled = true;
                        widgetItens.dataSource.data = [];
                        widgetItens.activate();
                        widget.openTab('gridProdutosTransferencia');
                    }
            }
            //save para editar tranferencias
            else {
                General.saveCrud(widget).then(
                    function(Success) {
                        this.controlaStatusWidgets(widget, widget.name, true);
                    }.bind(this),
                    function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                );
            }
        }
        this.changeHideInconLabelVisible(widget.actions, 'Salvar', false, 'salvar', false);
    };
    
	this.getItensOfRequisicao = function(widgetItens, cdfilial, nrrequesto, itemData, firstTime = true) {
		if(!firstTime){
			const item = itemData.shift();
			if(item !== undefined){
				widgetItens.dataSource.data.shift();
				widgetItens.currentRow = item;
				widgetItens.currentRow.QTTOTLANCTO = item.QTREQUESTO;
				widgetItens.currentRow.IDCNTRESTOQ = 'S';
				this.setCdfilimovi(widgetItens);
				this.callInformacoesComplementares(widgetItens).then(_=>{
					this.setValorUnitario(widgetItens).then(_ => {
						widgetItens.dataSource.data.push(widgetItens.currentRow);
						this.getItensOfRequisicao(widgetItens, cdfilial, nrrequesto, itemData, false);
					});
				});
			}
		}else{
		    const row = {CDFILIAL: cdfilial, NRREQUESTO: nrrequesto };
		    
			Est57000_TransferenciaEstoque_Service.buscaProdutosRequisicao(row).then(itens => {
				widgetItens.dataSource.data = itens.dataset.itrequesto_itens_requisicao;
				widgetItens.dataSource.data.forEach(item=>{
				    item.__is_new = true;
                    item.checkRepeat = true;
                    item.itemInserido = false;
				    item.CDALMOXARIFE = widgetItens.getParent().currentRow.CDALMOXSAID;
                    item.CDLOCALESTOQ = widgetItens.getParent().currentRow.CDLCESTSAID;
				});
				const data = Util.clone(widgetItens.dataSource.data);
				this.getItensOfRequisicao(widgetItens, cdfilial, nrrequesto, data, false);
			});
		}
		
	};
	
	this.setCdfilimovi = function(widget) {
		var newRow  = widget.currentRow;
		newRow.CDFILIMOVI = EstUtil.getFieldValue('CDFILIAL', 'gridTransferencia', true);
	};
	
  	this.focusAddProduto = function(widget) {
		this.enabledWidget(true);
		widget.call = 'insertTransferencia';
		widget.activate();
		widget.floatingControl.refreshAction = false;
	};
	
	this.changeHideInconLabelVisible = function(data, label, hide, name, visibility) {
		data.forEach(element=>{
			if(element.name === name) {
				element.label = label;
				element.hideIcon = hide;
				element.isVisible = visibility;
			}
		});
	};
	
	this.enabledWidget = function(enabled) {
		const widget = templateManager.container.getWidget('gridProdutosTransferencia');
		widget.enabled = enabled;
	};
	
	this.callInformacoesComplementares = function(widget) {
		let promise = ZHPromise.defer();
		if(widget.currentRow.CDARVPROD) {
			widget.promise = promise;
			let widgetTransf = widget.container.getWidget('gridTransferencia');
			let filterRow = isset(() => widgetTransf.appliedFilter.FILTER_ROW)? widgetTransf.appliedFilter.FILTER_ROW : false;
			if(isset(() => filterRow.CDALMOXARIFE)){
				if(filterRow.CDALMOXARIFE != ' ')
					widget.currentRow.CDALMOXARIFE = filterRow.CDALMOXARIFE;
			}
			if(isset(() => filterRow.CDLOCALESTOQ)){
				if(filterRow.CDLOCALESTOQ != ' ')
					widget.currentRow.CDLOCALESTOQ = filterRow.CDLOCALESTOQ;
			}
			Lib00206_InfComplProduto_Controller.infComplementares(widget, widget.currentRow);
		} else {
			this.changeReadOnlyByNm(widget, "QTTOTLANCTO", true);
			this.clearRowItens(widget, true);
			promise.reject();
		}
		return promise;
	};
	
	const isset = (accessor) => {
	  try {
	    // Note we're seeing if the returned value of our function is not
	    // undefined
	    return typeof accessor() !== 'undefined' && accessor() !== null;
	  } catch (e) {
	    // And we're able to catch the Error it would normally throw for
	    // referencing a property of undefined
	    return false;
	  }
	};
	
	this.setValorUnitario = function(widget) {
		const deffer = ZHPromise.defer();
		Est57000_TransferenciaEstoque_Service.getCdtipocusto(widget.currentRow.CDFILIAL).then(function(cdtipocusto){
			Est57000_TransferenciaEstoque_Service.setBlankLocalEstFields(widget);
			ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(
				widget.currentRow.CDFILIAL,
                widget.currentRow.CDPRODUTO,
                widget.getParent().currentRow.DTMOVIESTQ,
                cdtipocusto,
                widget.currentRow.CDALMOXARIFE,
                widget.currentRow.CDLOCALESTOQ,
                widget.currentRow.NRLOTEESTQ,
                widget.currentRow.NRSUBLOTE
			).then(function(success){
				const consulta = success.dataset.consultaCustoQuantidadeProduto;
				widget.currentRow.QTESTOQDIA = consulta.QTESTOQDIA;
				widget.currentRow.VRUNILANCTO = consulta.VRCUSTOPROD;
				Est57000_TransferenciaEstoque_Service.setVrTotLancto(widget.currentRow);
				widget.currentRow.COMPLETO = 'S';
				deffer.resolve();
			}, function(error){
				ScreenService.showMessage(error.data.error);
				deffer.reject();
			});
		}, function(error){
			ScreenService.showMessage(error.data.error);
			deffer.reject();
		});
		return deffer;
	};
	
    this.cancelProdRequisicao = function(args) {
        var widget = args.owner.widget;
		this.changeHideInconLabelVisible(widget.actions, 'Voltar', true, 'voltarPagina', true);
		this.changeHideInconLabelVisible(widget.actions, 'Salvar', true, 'saveControl', false);
		this.changeHideInconLabelVisible(widget.actions, 'Cancelar', true, 'cancelProdRequisicao', false);
        templateManager.container.getWidget('gridTransferencia').enabled = true;
        templateManager.container.getWidget('gridTransferencia').reload();
        General.backOrCancel(args);
    };

    this.checkProdutosCompletos = function(data) {
        var validação = true;
        data.forEach(function(produto) {
            if (produto.COMPLETO !== 'S' && validação === true) {
                validação = false;
                
                // ScreenService.showMessage(mensagens.produtoIncompleto + produto.NMPRODUTO + '.');
                
                /* MSG NOVA */
				var variaveis = {
                    NMPRODUTO: produto.NMPRODUTO
                };
				
				MessageService.showMessageByCode("PRODUTOIRREGULAR", variaveis);
				/* FIM MSG NOVA */
                
            }
        });
        return validação;
    };

    this.backProdRequisicao = function(widget) {
        let parent = widget.getParent();
        if(parent.currentRow.__is_new)
            parent.dataSource.data.pop();
        
        ScreenService.goBack();
        
    };
    
    this.SaveItems = function(widgetItens,widgetTransf,dataItems) {
        if(dataItems.length != 0){
            let ignoredKeys = ["__rightActions", "__leftActions", "__createdLocal", "__index", "$error"];
            let changedRows = [];
            
            dataItems.forEach(row=>{
                if(row.changed == true){
                    delete row.__rightActions;
                    changedRows.push(row);
                }
            });
            
            let rows = {
                    "transferencia": Util.clone(widgetItens.getParent().currentRow, ignoredKeys),
                    "produtos": changedRows
                };
            
            if(changedRows.length > 0){
                if(changedRows[changedRows.length-1].__is_new) widgetItens.currentRow = changedRows[changedRows.length-1];
            }else{
                ScreenService.showMessage('Não há novos itens para serem salvos.');
            }
            
            if(widgetTransf.currentRow.__is_new){
                if (widgetItens.currentRow.__is_new) {
                    Est57000_TransferenciaEstoque_Service.salvarNovaTransferencia(rows).then(function(Success) {
                        
                        widgetTransf.currentRow.NRORG = Success.dataset.transferencia.nrorg;
                        widgetTransf.currentRow.NRCTRLMOVEST = Success.dataset.transferencia.nrctrlmovest;
                        widgetTransf.currentRow.NRLANESTENTR = Success.dataset.transferencia.nrlanestentr;
                        widgetTransf.currentRow.NRLANESTSAID = Success.dataset.transferencia.nrlanestsaid;
                        widgetItens.dataSourceFilter[1].value = Success.dataset.transferencia.nrlanestsaid;
                        widgetTransf.currentRow.__is_new = false;
                        
                        widgetTransf.view();
                        widgetItens.list();
                        
                        this.changeHideInconLabelVisible(widgetItens.actions, 'Salvar', false, 'saveControl', false);
                        this.changeHideInconLabelVisible(widgetItens.actions, 'Importar por txt', false, 'importTxt', false);
                        
                    }.bind(this),
                    function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    });
                }
            }else{
                if(widgetItens.currentRow.__is_new){
                    Est57000_TransferenciaEstoque_Service.salvarNovaTransferencia(rows).then((Success)=> {
                        
                        this.changeHideInconLabelVisible(widgetItens.actions, 'Salvar', false, 'saveControl', false);
                        this.changeHideInconLabelVisible(widgetItens.actions, 'Importar por txt', false, 'importTxt', false);
                        
                        widgetItens.activate();
                        widgetItens.list();
                        widgetItens.reload();
                        
                    },function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    });
                }else{
                    Est57000_TransferenciaEstoque_Service.editarProduto(rows).then((Success)=> {
                        for(let key = 0; key < changedRows.length; key++){
                            changedRows[key].__is_new = false;
                            changedRows[key].QTLANCTOEST = Success.dataset.produto[key].qtlanctoest;
                            changedRows[key].QTTOTLANCTO = Success.dataset.produto[key].qttotlancto;
                            changedRows[key].VRTOTLANCTO = Success.dataset.produto[key].vrtotlancto;
                        }
                        this.changeHideInconLabelVisible(widgetItens.actions, 'Salvar', false, 'saveControl', false);
                        this.changeHideInconLabelVisible(widgetItens.actions, 'Importar por txt', false, 'importTxt', false);
                        widgetItens.activate();
                        widgetItens.list();
                        widgetItens.reload();
                    },function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    });
                }
            } 
        }
        
    };
    
    this.SaveItemsWithRequisition = function(widgetItens,widgetTransf,dataItemsFromRequisition) {
        const promise = ZHPromise.defer();
        if(dataItemsFromRequisition.length != 0){
            var row = {
                transferencia: widgetTransf.currentRow,
                itens: dataItemsFromRequisition
            };

            if (this.checkProdutosCompletos(widgetItens.dataSource.data)) {
                Est57000_TransferenciaEstoque_Service.salvarNovaTransferenciaComRequisicao(row).then(function(Success) {
                    
                    widgetTransf.currentRow.NRORG = Success.dataset.transferencia.nrorg;
                    widgetTransf.currentRow.NRCTRLMOVEST = Success.dataset.transferencia.nrctrlmovest;
                    widgetTransf.currentRow.NRLANESTENTR = Success.dataset.transferencia.nrlanestentr;
                    widgetTransf.currentRow.NRLANESTSAID = Success.dataset.transferencia.nrlanestsaid;
                    
    				this.changeHideInconLabelVisible(widgetItens.actions, 'Voltar', true, 'voltarPagina', true);
    				this.changeHideInconLabelVisible(widgetItens.actions, 'Salvar', true, 'saveControl', false);
    				this.changeHideInconLabelVisible(widgetItens.actions, 'Cancelar', true, 'cancelProdRequisicao', false);
                    
                    widgetItens.enabled = true;
                    widgetTransf.enabled = true;
                    
                    ScreenService.closeSwipe();
                    
                    widgetItens.list();
                    widgetTransf.list();
                    widgetTransf.activate();
                    widgetTransf.reload();
                    promise.resolve();
                }.bind(this),function(callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                        promise.reject();
                    }
                });
            }
        }else{
            promise.resolve();
        }
        return promise;
    };
    
    this.SaveItemsController = function(widgetItens){
        const widgetTransf = templateManager.container.getWidget('gridTransferencia');
        
        let dataItems = widgetItens.dataSource.data.filter(item => {
            return (!item.hasOwnProperty('NRREQUESTO')) || (item.NRREQUESTO == null) ;
        });
        
        let dataItemsFromRequisition = widgetItens.dataSource.data.filter(item => {
            return ((item.hasOwnProperty('NRREQUESTO')) && (item.NRREQUESTO != null)) && (item.hasOwnProperty('itemInserido'));
        });
        
        this.SaveItemsWithRequisition(widgetItens,widgetTransf,dataItemsFromRequisition).then(_=>{
            this.SaveItems(widgetItens,widgetTransf,dataItems);
        },_ => {});
        
    };
    
    this.checkRequisicaoComplementarCreation = function(widget) {
        var promise = ZHPromise.defer();
        var item = widget.currentRow;

        Est57000_TransferenciaEstoque_Service.verificaEstoqueProduto(widget.currentRow).then(function(success) {
            var result = 0;
            if (success.dataset.lote_infCompl_almox[0]) {
                result = success.dataset.lote_infCompl_almox[0].QTESTOQDIA;
            }
            item.QTESTOQDIA = result;
            var filter = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIMOVI
            }];

            General.callRestEngine('est#/crud/paramfilial', 'FilterData', filter).then(function(success) {
                widget.currentRow.IDREQCOMPEST = success.dataset.paramfilial[0].IDREQCOMPEST;
                if (this.checkShouldCreateRequisicaoComplementar(item)) {
                    var msg = "Quantidade requisitada não disponível em estoque para o produto " + item.NMPRODUTO + " : " + item.QTESTOQDIA + " " + item.SGUNIDADE + ". Deseja gerar uma requisição complementar?";

                    ScreenService.confirmMessage(msg,
                        'question',
                        function() { //sim
                            item.createReqComp = true;
                            item.QTLANCREQCOMP = item.QTREQUESTO - item.QTESTOQDIA;
                            ScreenService.closeSwipe();
                            widget.currentRow.COMPLETO = 'S';
                            promise.resolve();
                        }.bind(this),
                        function() { //não
                            item.createReqComp = false;
                            ScreenService.closeSwipe();
                            widget.currentRow.COMPLETO = 'S';
                            promise.resolve();
                        }.bind(this));
                }
                else {
                    ScreenService.closeSwipe();
                    widget.currentRow.COMPLETO = 'S';
                    promise.resolve();
                }
            }.bind(this));
        }.bind(this));

        return promise;
    };

    this.checkShouldCreateRequisicaoComplementar = function(item) {

        return item.NRREQUESTO && item.IDREQCOMPEST == 'S' &&
            item.QTESTOQDIA == item.QTTOTLANCTO &&
            item.QTESTOQDIA < item.QTREQUESTO;
    };
    
    this.checkSave = function(widget){
        
        if (widget.isValid()){
            let row = widget.currentRow;
            if (!Est57000_TransferenciaEstoque_Service.checaItensDaRetirada(this.copyDataWidgetItens(widget.dataSource.data), row.CDARVPROD, row.CDALMOXARIFE, row.CDLOCALESTOQ, row.NRLOTEESTQ, row.NRSUBLOTE, row.itemInserido)) {
                this.checkRequisicaoComplementarCreation(widget).then(function() {
                    widget.currentRow.novo = false;
                    let data = widget.dataSource.data;
                    data[data.length - 1].itemInserido = true;
                }.bind(this));
                widget.currentRow.COMPLETO = 'S';
                
                this.controlButtonSaveAndImportVisibility(widget);
            }else {
                ScreenService.showMessage('Produto informado já está sendo incluido para essa transferência.');
            }
        }else {
            if (widget.currentRow.$error.QTTOTLANCTO[0]) ScreenService.showMessage('Quantidade indisponivel em estoque');
        }
            
    };

    this.editItens = function(widget) {

        widget.backupRow = Util.clone(widget.currentRow, ['__rightActions', '__leftActions']);
        widget.edit();

    };

    this.checkAlmoxStatus = function(args) {
        var widget = args.owner;
        var widgetTransferencia = widget.getParent();
        if (widget.currentRow.COMPLETO !== 'S' && widgetTransferencia.mode == 'edit') {
            widget.currentRow.CDFILIMOVI = widget.getParent().currentRow.CDFILIMOVI;
            this.editItens(widget);
            this.callInformacoesComplmentares(widget);
        }
    };

    this.changeReadOnlyByNm = function(widget, name, read) {
        widget.getField(name).readOnly = read;
    };
    
    this.callInformacoesComplmentares = function(widget) {
        this.getFilialLogada().then(function(success) {
            widget.currentRow.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            if (widget.currentRow.CDARVPROD) {
                widget.paramInfoCompl.AtuEstoq = widget.currentRow.__is_new;
                widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
                widget.currentRow.CDFILIMOVI = widget.getParent().currentRow.CDFILIMOVI;
                Lib00206_InfComplProduto_Controller.infComplementares(widget, widget.currentRow);

            }
            else {
                this.changeReadOnlyByNm(widget, "QTTOTLANCTO", true);
                this.clearRowItens(widget, true);
            }
        }.bind(this));

    };

    this.deletarProduto = function(widget) {
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', (success)=> {
            delete widget.currentRow.__rightActions;
            var rows = {
                "transferencia": widget.getParent().currentRow,
                "produtos": widget.currentRow
            };
            var widgetTransferencia = widget.getParent();
            if (widgetTransferencia.mode == 'edit') {
                if (widget.currentRow.NRREQUESTO) {
                    var index = widget.dataSource.data.indexOf(widget.currentRow);
                    widget.dataSource.data.splice(index, 1);
                    ScreenService.goBack();
                }else{
                    this.removeItemDataSource(widget);
                }
                this.controlButtonSaveAndImportVisibility(widget);
            }else{
                Est57000_TransferenciaEstoque_Service.deletarProduto(rows).then(
                    function(Success) {
                        ScreenService.closeSwipe().then(()=> {
                            widget.activate();
                        });
                        widget.reload();
                    },(error)=> {
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        }
                        else {
                            ScreenService.showMessage(error.data.error);
                        }
                    }
                );
            }
        });
    };
    
    this.removeItemDataSource = function(widget){
		var itens = widget.dataSource.data;
		for (var i = 0; i < itens.length; i++) {
			if(itens[i].CDARVPROD === widget.currentRow.CDARVPROD &&
			 itens[i].CDALMOXARIFE === widget.currentRow.CDALMOXARIFE &&
			 itens[i].CDLOCALESTOQ === widget.currentRow.CDLOCALESTOQ &&
			 itens[i].NRLOTEESTQ === widget.currentRow.NRLOTEESTQ &&
			 itens[i].NRSUBLOTE === widget.currentRow.NRSUBLOTE
			) {
				itens.splice(i, 1);
				i = itens.length;
				ScreenService.closeSwipe();
			}
		}
	};
    
    this.clearRowItens = function(widget, clearAll) {
        if (widget.currentRow.COMPLETO === 'S') {
            widget.currentRow.QTREQUESTO = "";
            widget.currentRow.QTLANCTOEST = "";
            widget.currentRow.VRTOTLANCTO = "";
            if (clearAll) {
                widget.currentRow.NMPRODUTO = "";
                widget.currentRow.CDARVPROD = "";
                widget.currentRow.SGUNIDADE = "";
            }
        }
    };

    this.editItensTransferencia = function(widget) {
        var widgetTransferencia = widget.getParent();
        if (widgetTransferencia.mode == 'edit') {
            if (widget.currentRow.NRREQUESTO) {
                this.callInformacoesComplmentares(widget);
                widget.backupRow = Util.clone(widget.currentRow, ['__rightActions', '__leftActions']);
                widget.edit();
                widget.getField('QTTOTLANCTO').readOnly = true;
            }else{
                widget.edit();
            }
        }
        else {
            widget.edit();
            widget.getField('QTTOTLANCTO').readOnly = false;
            widget.currentRow.IDQUANTID = 'S';
            Est57000_TransferenciaEstoque_Service.verificaEstoqueProduto(widget.currentRow).then(function(success) {
                var result = 0;
                if (success.dataset.lote_infCompl_almox[0]) {
                    result = success.dataset.lote_infCompl_almox[0].QTESTOQDIA;
                }
                var mensagem = "Posição Estoque: ".concat(result);
                widget.getField('QTTOTLANCTO').validations.max = { "value": result, "message": mensagem };
            });
        }
    };

    this.deletarTransferencia = function(widget) {
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function(success) {
            this.getFilialLogada().then(function(success) {
                Est57000_TransferenciaEstoque_Service.deletarTransferencia(widget.currentRow).then(
                    function(Success) {
                        ScreenService.closeSwipe().then(function() {
                            widget.activate();
                        });
                        widget.reload();
                    }.bind(this),
                    function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                );
            }.bind(this));
        }.bind(this));
    };

    this.setAlmoxRequisicao = function(widget) {
        if (widget.currentRow.NRREQUESTO) {
            var row = {
                NRREQUESTO: widget.currentRow.NRREQUESTO
            };
            var controle = templateManager.container.getWidget('gridTransferencia').appliedFilter.FILTER_ROW;
            if (controle.IDUTILALMOX === 'S') {
                Est57000_TransferenciaEstoque_Service.getAlmoxRequisicao(row).then(function(success) {
                    var result = success.dataset.getAlmoxRequisicao[0];
                    if (result.CDALMOXSAIDA) {
                        widget.currentRow.DSALMOXSAID = result.DSALMOXSAIDA;
                        widget.currentRow.CDALMOXSAID = result.CDALMOXSAIDA;
                    }
                    if (result.CDALMOXENTR) {
                        widget.currentRow.DSALMOXENTR = result.DSALMOXENTR;
                        widget.currentRow.CDALMOXENTR = result.CDALMOXENTR;
                    }
                    if (controle.IDUTILLCESTQ === 'S') {
                        widget.getField('DSLOCALSAID').readOnly = false;
                        widget.getField('DSLOCALENTR').readOnly = false;
                        if (result.CDLESTQSAIDA) {
                            widget.currentRow.DSLOCALSAID = result.DSLESTQSAIDA;
                            widget.currentRow.CDLOCALSAID = result.CDALMOXSAIDA;
                        }
                        if (result.CDLESTQENTR) {
                            widget.currentRow.DSLOCALENTR = result.DSLESTQENTR;
                            widget.currentRow.CDLOCALENTR = result.CDLESTQENTR;
                        }
                    }

                });
            }
        }
    };

    this.getFilialLogada = function(widget) {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    this.controlaLoteProduto = function(field) {
        var widget = field.widget;
        var filtroPopupCurrentRow = widget.getParent().appliedFilter.FILTER_ROW;
        field.reload().then(
            function(Success) {
                if (filtroPopupCurrentRow.IDUTILLOTE == 'S') {
                    if (widget.currentRow.CDARVPROD) {
                        if (widget.currentRow.IDUTCTRLLOTE == 'S') {
                            if (field.dataSource.data.length == 0) {
                                ScreenService.showMessage('Lote não cadastrado para o produto informado.');
                                field.dataSource.data = null;
                            }
                        }
                        else {
                            ScreenService.showMessage('Produto não controla lote.');
                            field.dataSource.data = null;
                        }
                    }
                    else {
                        ScreenService.showMessage('Lote não cadastrado para o produto informado.');
                        field.dataSource.data = null;
                    }
                }
            },
            function(callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    this.copyDataWidgetItens = function(data) {
        var copy = [];
        data.forEach(function(item) {
            copy.push(Util.clone(item, ['__rightActions', '__leftActions']));
        });
        return copy;
    };
    
    var setCurrentRowWithOutData = function(currentRow, valuesToSetOnCurrentRow, outDataValue) {
        for (var key in outDataValue) {
            if(Array.isArray(outDataValue[key])){
                let newArray = [];
                outDataValue[key].forEach(value => newArray[value] = value); // jshint ignore:line
                setCurrentRowWithOutData(currentRow, valuesToSetOnCurrentRow, newArray);
            }
            else
                currentRow[outDataValue[key]] = valuesToSetOnCurrentRow[key];
        }
    };
    
    // var decodeTextViewFloat = function (fieldRow) {
    // 	if(typeof fieldRow === 'string'){
    //         fieldRow = fieldRow.replace(/\./g, '');
    //         fieldRow = fieldRow.replace(',', '.');
    // 	}
    //     var viewRow = parseFloat(fieldRow);
    // 	viewRow = isNaN(viewRow) ? "" : viewRow;
    //     return addThousandSeparators(viewRow);
    // };
    
    // function addThousandSeparators(value) {
    //     value += '';
    //     var x = value.split(',');
    //     var x1 = x[0];
    //     var x2 = x.length > 1 ? ',' + x[1] : '';
    //     var rgx = /(\d+)(\d{3})/;
    //     while (rgx.test(x1)) {
    //         x1 = x1.replace(rgx, '$1.$2');
    //     }

    //     return x1 + x2;
    // }
    
    this.openAnexoSwipe = function() {
        let widgetImportTxt = templateManager.container.getWidget('wdgUploadTxt');
        widgetImportTxt.isVisible = true;
        ScreenService.openSwipe(widgetImportTxt).then(function(){
            widgetImportTxt.newRow();
        });
    };
    
    this.closeAnexoSwipe = function(widget) {
    	let widgetProduto = templateManager.container.getWidget('gridProdutosTransferencia');
    	widgetProduto.activate();
        widget.dataSource.data.pop();
        ScreenService.closeSwipe();
        widget.isVisible = false;
    };
    
    this.importarProdutosTxt = function(widget){
        
        if (!widget.isValid()) {
            return;
        }
        
        var widgetProduto = templateManager.container.getWidget('gridProdutosTransferencia');
        var widgetTransferencia = templateManager.container.getWidget('gridTransferencia');
        var ignoredKeys = ["__rightActions", "__createdLocal", "__index", "$error"];
        
        widget.isVisible = false;
    	ScreenService.closeSwipe().then( () => {
            widget.currentRow.CDFILIAL = widgetTransferencia.currentRow.CDFILIAL;
            widget.currentRow.DTMOVIESTQ = widgetTransferencia.currentRow.DTMOVIESTQ;
            widget.currentRow.CONTAINER = widget.container.name;
            widget.currentRow.CDFILIMOVI = widgetTransferencia.appliedFilter.FILTER_ROW.CDFILIAL;
            this.getParamsImpEst(widget.currentRow.CDFILIMOVI).then(response => {
                if(response.dataset.paramimpest_params_codebar.length > 0){
                    widget.currentRow.PARAMS = response.dataset.paramimpest_params_codebar[0];
                    Est57000_TransferenciaEstoque_Service.importarProdutosTxt(Util.clone(widget.currentRow, ignoredKeys)).then(success => {
                        var itens = success.dataset.itensTransferencia;
                        var itensDataSource = widgetProduto.dataSource;
        
                        if(itens.length > 0) {
                            widgetTransferencia.currentRow.DTMOVIESTQ = itens[0].DTMOVIESTQ;
                            itensDataSource.data = itens;
                            
                            itensDataSource.data.forEach( (row) => {
                                
                                Est57000_TransferenciaEstoque_Service.getCdtipocusto(row.CDFILIAL).then((cdtipocusto)=>{
									row.DTLANCMOVI = widgetTransferencia.currentRow.DTMOVIESTQ;
									
									if(!row.CDALMOXARIFE) row.CDALMOXARIFE = ' ';
									if(!row.CDLOCALESTOQ) row.CDLOCALESTOQ = ' ';
									if(!row.NRLOTEESTQ) row.NRLOTEESTQ = ' ';
									if(!row.NRSUBLOTE) row.NRSUBLOTE = ' ';
									
									ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(
										row.CDFILIAL,
										row.CDPRODUTO,
										row.DTLANCMOVI.substr(0, 10),
										cdtipocusto,
										row.CDALMOXARIFE,
										row.CDLOCALESTOQ,
										row.NRLOTEESTQ,
										row.NRSUBLOTE
									).then((success)=>{
										var consulta = success.dataset.consultaCustoQuantidadeProduto;
										row.QTESTOQDIA = consulta.QTESTOQDIA;
										row.VRUNILANCTO = consulta.VRCUSTOPROD;
								        Est57000_TransferenciaEstoque_Service.setVrTotLancto(row);
										row.__is_new = true;
                                        row.changed  = true;
										row.COMPLETO = 'S';
									});
								});
                            });
							this.controlButtonSaveAndImportVisibility(widgetProduto);
                        }else{
                            ScreenService.showMessage("Não foram encontrados nenhum produto a partir do arquivo");
                        }
                    }).catch(error => {
                        if(error.data){
                            if (error.data.errorCode == 400) {
                            	ScreenService.closeSwipe().then(()=>{
                                	let impAction = widget.getParent().getAction("importTxt");
                                    this.openAnexoSwipe(impAction);
                            		ScreenService.showMessage(error.data.error);
                            	});
                            }else{
                            	ScreenService.showMessage(error.data.error);
                            }
                        }else{
                            ScreenService.showMessage(error);
                        }
                        
                    });
                } else{
                    ScreenService.showMessage("Parâmetros para importação de estoque não encontrados.");
                }
            }).catch(error => {
                if(error.data){
                    ScreenService.showMessage(error.data.error);
                }else{
                    ScreenService.showMessage(error);
                }
        	});
        });
        widgetProduto.activate();
        widgetProduto.list();
        widgetProduto.reload();
    };
    
    this.getParamsImpEst = function(cdfilial) {
        var filter = [
                {
                    "name": "CDFILPARIMPEST",
                    "operator": "=",
                    "value": cdfilial
                }
		    ];
        return General.callRestEngine('est_ajuste#/crud/paramimpest_params_codebar', 'FilterData', filter);
    };
 
    this.controlButtonSaveAndImportVisibility = function(widget){
        let widgetTranferencia = templateManager.container.getWidget('gridTransferencia');
        if(!widgetTranferencia.currentRow.NRCTRLMOVEST){
            if(widget.dataSource.data.length != 0){
                this.changeHideInconLabelVisible(widget.actions, 'Salvar', true, 'saveControl', true);
                this.changeHideInconLabelVisible(widget.actions, 'Importar por txt', false, 'importTxt', false);
            }else{
                if (widgetTranferencia.currentRow.NRREQUESTO) {
                    this.changeHideInconLabelVisible(widget.actions, 'Salvar', true, 'saveControl', true);
                    this.changeHideInconLabelVisible(widget.actions, 'Importar por txt', false, 'importTxt', false);
                }else{
                    this.changeHideInconLabelVisible(widget.actions, 'Salvar', false, 'saveControl', false);
                    this.changeHideInconLabelVisible(widget.actions, 'Importar por txt', true, 'importTxt', true);
                }
            }
        }else{
            if(widget.currentRow.__is_new){
                if(widget.dataSource.data.length != 0){
                    this.changeHideInconLabelVisible(widget.actions, 'Salvar', true, 'saveControl', true);
                    this.changeHideInconLabelVisible(widget.actions, 'Importar por txt', false, 'importTxt', false);
                }else{
                    this.changeHideInconLabelVisible(widget.actions, 'Salvar', false, 'saveControl', false);
                    this.changeHideInconLabelVisible(widget.actions, 'Importar por txt', true, 'importTxt', true);
                }
            }else{
                this.changeHideInconLabelVisible(widget.actions, 'Salvar', false, 'saveControl', false);
                this.changeHideInconLabelVisible(widget.actions, 'Importar por txt', false, 'importTxt', false);
            }
        }
    };
     
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Est57000_TransferenciaEstoque_Controller', Est57000_TransferenciaEstoque_Controller);
});
