var Ger03300_FecharDia_Controller = function(ScreenService, Ger03300_FecharDia_Repository, templateManager, Unidade_Repository, General) {

    this.fecharDia = function(widget) {
        var proxDia =  widget.getField('PROXDIAPROCESS').value();
        var dataProces =  widget.getField('DIAPROCESS').value();
        var cdfilial = widget.getField('CDFILIAL').value();
        ScreenService.showLoader();
        Ger03300_FecharDia_Repository.getDataSource("est#/data_proxdataproces").then(((dataSugerida)=>{
            if (moment(dataProces,'DD/MM/YYYY').isAfter(moment(dataSugerida[0].DTDATA,'DD/MM/YYYY'))){
                ScreenService.alertNotification('O fechamento do dia já foi realizado para a data de processamento informada. Clique em OK para atualizar a data de processamento.');
            }else if(proxDia === null || proxDia === undefined || proxDia === ""){
                ScreenService.alertNotification('Prox. data de processamento deve ser informada.');
            }else if(moment(proxDia,'DD/MM/YYYY').isBefore(moment(dataProces,'DD/MM/YYYY'))){
                ScreenService.alertNotification('Próxima data de processamento deve ser maior que a data de processamento atual.');
            }else{
                var filterValues = [];
                filterValues.CDFILIAL = cdfilial;
                filterValues.DTPROCESSA = dataProces;
                filterValues.PROXDTPROCESSA = proxDia;

                this.callFecharDia(filterValues, false, function(response) {
                    if(response.dataset.fechardia.userprompt)
                        ScreenService.confirmMessage(response.messages[0].message, 'question', function() {
                            this.callFecharDia(response.dataset.fechardia, true, this.callbackFecharDia);
                        }.bind(this));
                    else
                        this.callbackFecharDia(response);
                });
            }
            this.setDtProcessa(cdfilial);
            //ScreenService.hideLoader();
        }).bind(this));
    };

    this.callbackFecharDia = function(response) {
        this.setDtProcessa(response.dataset.fechardia.CDFILIAL);

        if(response.dataset.fechardia.InveRota) {
            ScreenService.confirmMessage(response.messages[0].message + ' Deseja emitir o relatório para Inventário rotativo?').then(function(){
                ScreenService.openWindow('est#ger03301_relatorio_inventario_rotativo');
            });
        } else {
            ScreenService.showMessage(response.messages[0].message);
            templateManager.headerInfo = templateManager.headerInfo.replace(response.dataset.fechardia.DTPROCESSA, response.dataset.fechardia.PROXDTPROCESSA);
            templateManager.userData.descriptions[0] = templateManager.userData.descriptions[0].replace(response.dataset.fechardia.DTPROCESSA, response.dataset.fechardia.PROXDTPROCESSA);
        }
        
        ScreenService.hideLoader();
    };

    this.callFecharDia = function(filterValues, SKIPINVENTARIOCEGO, callback) {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filterValues.CDFILIAL
            },
            {
                "name": "DTPROCESSA",
                "operator": "=",
                "value": filterValues.DTPROCESSA
            },
            {
                "name": "PROXDTPROCESSA",
                "operator": "=",
                "value": filterValues.PROXDTPROCESSA
            },
            {
                "name": "SKIPINVENTARIOCEGO",
                "operator": "=",
                "value": SKIPINVENTARIOCEGO
            }
        ];
        
        Ger03300_FecharDia_Repository.consulta('est#/fechardia', filter).then(callback.bind(this),
            function(error) {
                ScreenService.showMessage(error.data.error);
                ScreenService.hideLoader();
            }
            
        );
    };

    this.fecharDiaOnEnter = function(widget, cdfilialField, nmfilialField) {
        var cdunidade;
        var nmunidade;
        var row = {
            CDFILIAL: getLocalVar('CDFILIAL')
        };
        
        General.callRestEngine("est#/getDadosFecharDia", "Row", row).then((result) => {
            result = result.dataset.dados_fechardia;
            cdfilialField.setValue(result.CDFILIAL);
            nmfilialField.setValue(result.NMFILIAL);
            
            widget.getField('DIAPROCESS').setValue(moment(result.DTPROCESSA,'DD/MM/YYYY').format('DD/MM/YYYY'));
            widget.getField('NMDIAPROCESS').setValue(moment(result.DTPROCESSA,'DD/MM/YYYY').format('dddd'));
            
            if(result.IDALTDTFECDIA === 'S'){
                widget.getField('PROXDIAPROCESS').readOnly = false;
            }else{
                widget.getField('PROXDIAPROCESS').readOnly = true;
            }
            if(result.IDCONSDIAUTFEC != 'S'){
                widget.getField('PROXDIAPROCESS').setValue(moment(result.DTPROCESSA,'DD/MM/YYYY').add(1,'day').format('DD/MM/YYYY'));
                widget.getField('NMPROXDIAPROCESS').setValue(moment(result.DTPROCESSA,'DD/MM/YYYY').add(1,'day').format('dddd'));
                
                let nextDate = widget.getField('PROXDIAPROCESS').value();
                Ger03300_FecharDia_Repository.setDataSource("est#/data_proxdataproces", nextDate);
            }else{
                var filter = [{
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": result.CDFILIAL
                },{
                    "name": "DTPROCES",
                    "operator": "=",
                    "value": moment(result.DTPROCESSA,'DD/MM/YYYY').format('DD/MM/YYYY')
                }];
                
                Ger03300_FecharDia_Repository.consulta("est#/data_proxdataproces", filter).then(function(banco2) {
                    var proxdata = banco2.dataset.data_proxdataproces;
                    widget.getField('PROXDIAPROCESS').setValue(proxdata[0].DTDATA);
                    widget.getField('NMPROXDIAPROCESS').setValue(moment(proxdata[0].DTDATA,'DD/MM/YYYY').format('dddd'));
                    Ger03300_FecharDia_Repository.setDataSource("est#/data_proxdataproces", proxdata);
                }, function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            }
        });
    };

    this.setDtProcessa = function(cdfilial){
        var container = templateManager.container;
        var widget = container.getWidget('fecharDia');
        var filial = widget.getField('CDFILIAL').value();
        var filterParamgeral = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        Ger03300_FecharDia_Repository.consulta("est#/paramfilial_paramvalidacoes", filterParamgeral).then(function(banco) {
            var paramGeral = banco.dataset.paramfilial_paramvalidacoes;
            widget.getField('DIAPROCESS').setValue(moment(paramGeral[0].DTPROCESSA,'DD/MM/YYYY').format('DD/MM/YYYY'));
            widget.getField('NMDIAPROCESS').setValue(moment(paramGeral[0].DTPROCESSA,'DD/MM/YYYY').format('dddd'));
            if(paramGeral[0].IDALTDTFECDIA === 'S'){
                widget.getField('PROXDIAPROCESS').readOnly = false;
            }else{
                widget.getField('PROXDIAPROCESS').readOnly = true;
            }
            if(paramGeral[0].IDCONSDIAUTFEC != 'S'){
                widget.getField('PROXDIAPROCESS').setValue(moment(paramGeral[0].DTPROCESSA,'DD/MM/YYYY').add(1,'day').format('DD/MM/YYYY'));
                widget.getField('NMPROXDIAPROCESS').setValue(moment(paramGeral[0].DTPROCESSA,'DD/MM/YYYY').add(1,'day').format('dddd'));
            }else{
                var filter = [{
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                },{
                    "name": "DTPROCES",
                    "operator": "=",
                    "value": moment(paramGeral[0].DTPROCESSA,'DD/MM/YYYY').format('DD/MM/YYYY')
                }];
                Ger03300_FecharDia_Repository.consulta("est#/data_proxdataproces", filter).then(function(banco2) {
                    var proxdata = banco2.dataset.data_proxdataproces;
                    widget.getField('PROXDIAPROCESS').setValue(proxdata[0].DTDATA);
                    widget.getField('NMPROXDIAPROCESS').setValue(moment(proxdata[0].DTDATA,'DD/MM/YYYY').format('dddd'));
                    Ger03300_FecharDia_Repository.setDataSource("est#/data_proxdataproces", proxdata);
                }, function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            }
        });
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger03300_FecharDia_Controller', Ger03300_FecharDia_Controller);
});