var Ger03302_InventarioRotativo_Controller = function(ScreenService, ParamfilialService, ParamgeralService, templateManager, InventarioRotativo_Service, General, ZhFilterPreferences, EstUtil) {

    this.ajustou = false;

     this.validateInventarioRotativo = function(args){
        InventarioRotativo_Service.getOperadorLogado().then(function(operador) {
            operador = operador[0];
            var cdfilial = operador.CDFILIALSELECIONADA;
            var nrorg = operador.NRORG;
            var route = 'est#/validateInventarioRotativo';
            General.callRestEngine(route, 'Row', {'CDFILIAL': cdfilial})
            .then(function(response){
                var inventarioIsValid = (!!response.dataset) ? response.dataset.AtualizaInveRota[0] : false;
                if (inventarioIsValid) {
                    this.ABRIR_FILTRO = false;
                    ScreenService.openWindow("est#ger03302_blank_window").then(function(){
                        ScreenService.showMessage("<br />Não há inventário pendente para a unidade.");     
                    });
                }else{
                    this.ABRIR_FILTRO = true;
                }
            }.bind(this))
            .catch(function(error){
                ScreenService.showMessage(error.data.error);
            });
        }.bind(this))
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.onEnter = function(){
        var filterRow = {};
        var container = templateManager.container;
        var widgetGrid = container.getWidget('Lancamento');
        InventarioRotativo_Service.getOperadorLogado().then((operador) => {
            operador = operador[0];
            var cdfilial = operador.CDFILIALSELECIONADA;
            var nrorg = operador.NRORG;
            ParamfilialService.getParamfilial(nrorg,cdfilial).then((paramFilial) => {
                paramFilial= paramFilial[0];
                ParamgeralService.getParamgeral(nrorg).then((paramGeral) => {
                    paramGeral= paramGeral[0];
                    var dtprocessa = (paramGeral.IDUTILDTPROC === 'S') ? paramFilial.DTPROCESSA : moment().format("DD/MM/YYYY");
                    var idUtAlmox = paramFilial.IDUTILALMOX==='S';
                    var idUtLocal = paramFilial.IDUTILLCESTQ==='S';
                    var idUtLote = paramFilial.IDUTILLOTE==='S';
                    var fieldLocal = widgetGrid.getField("CDLOCALESTOQ");
                    var fieldAlmox = widgetGrid.getField("CDALMOXARIFE");
                    fieldAlmox.readOnly = !idUtAlmox;
                    fieldLocal.readOnly = !(idUtAlmox&&idUtLocal);
                    fieldAlmox.dataSource.name = (idUtLote) ? "est#/almoxarifado_inverotalote" : "est#/almoxarifado_inverota";
                    fieldLocal.dataSource.name = (idUtLote) ? "est#/localestoque_inverotalote" : "est#/localestoque_inverota";
                    if (idUtAlmox) {
                        fieldAlmox.filterProperties.validations = {required: true};
                    }else{
                        delete fieldAlmox.filterProperties.validations;
                    }
                    if (idUtLocal) {
                        fieldLocal.filterProperties.validations = {required: true};
                    }else{
                        delete fieldLocal.filterProperties.validations;
                    }
                    widgetGrid.getField("NRLOTEESTQ").isVisible = idUtLote;
                    widgetGrid.getField("NRSUBLOTE").isVisible = idUtLote;
                    widgetGrid.getField("DTVALILOTE").isVisible = idUtLote;
                    
                    
                    filterRow.CDFILIAL = cdfilial;
                    filterRow.NMFILIAL = getLocalVar('NMFILIAL');
                    filterRow.DTINVEROTA = dtprocessa;
                    filterRow.CDALMOXARIFE = idUtAlmox?null:' ';
                    filterRow.CDLOCALESTOQ = (idUtAlmox&&idUtLocal)?null:' ';
                    filterRow.UTLOTE = idUtLote;
                    /*widgetGrid.dataSourceFilter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": cdfilial
                        },{
                            "name": "DTINVEROTA",
                            "operator": "=",
                            "value": dtprocessa
                        },{
                            "name": "CDALMOXARIFE",
                            "operator": "=",
                            "value": idUtAlmox?null:' '
                        },{
                            "name": "CDLOCALESTOQ",
                            "operator": "=",
                            "value": (idUtAlmox&&idUtLocal)?null:' '
                        },{
                            "name":"UTLOTE",
                            "operator":"=",
                            "value":idUtLote
                        }
                    ];
                    fieldAlmox.dataSourceFilter[0].value = cdfilial;
                    fieldLocal.dataSourceFilter[0].value = cdfilial;
                    fieldAlmox.dataSourceFilter[1].value = dtprocessa;
                    fieldLocal.dataSourceFilter[1].value = dtprocessa;
                    */
                    var validaOpenFilter = true;
                    
                    //nao remover a linha do ignore do lint
                    /* jshint ignore:start */
                    while (!this.hasOwnProperty('ABRIR_FILTRO') || validaOpenFilter){
                        if (this.ABRIR_FILTRO){
                            //ZhGridFilter.startFiltering(templateManager.container.widgets[0]);
                            this.openFilter(templateManager.container.widgets[0], filterRow).then(opened => {
                                let filterWidget = templateManager.container.getActiveWidget();
                                var fieldLocalFilter = filterWidget.getField("CDLOCALESTOQ");
                                var fieldAlmoxFilter = filterWidget.getField("CDALMOXARIFE");
                                fieldAlmoxFilter.readOnly = !idUtAlmox;
                                fieldLocalFilter.readOnly = !(idUtAlmox&&idUtLocal);
                                fieldAlmoxFilter.dataSource.name = (idUtLote) ? "est#/almoxarifado_inverotalote" : "est#/almoxarifado_inverota";
                                fieldLocalFilter.dataSource.name = (idUtLote) ? "est#/localestoque_inverotalote" : "est#/localestoque_inverota";
                                if (idUtAlmox) {
                                    fieldAlmoxFilter.validations = {required: true};
                                }else{
                                    delete fieldAlmoxFilter.validations;
                                }
                                if (idUtLocal) {
                                    fieldLocalFilter.validations = {required: true};
                                }else{
                                    delete fieldLocalFilter.validations;
                                }
                            });
                        }
                        validaOpenFilter = false;
                    }
                    /* jshint ignore:end */
                });
            });
        });
    };
    
    this.onChangeFilial = function(args) {
        let filterWidget = args.owner.field.widget;
        let cdfilial = filterWidget.currentRow.CDFILIAL;
        let nrorg = getLocalVar('NRORG');
        ParamfilialService.getParamfilial(nrorg,cdfilial).then((paramFilial) => {
            paramFilial= paramFilial[0];
            ParamgeralService.getParamgeral(nrorg).then((paramGeral) => {
                paramGeral= paramGeral[0];
                var dtprocessa = (paramGeral.IDUTILDTPROC === 'S') ? paramFilial.DTPROCESSA : moment().format("DD/MM/YYYY");
                var idUtAlmox = paramFilial.IDUTILALMOX==='S';
                var idUtLocal = paramFilial.IDUTILLCESTQ==='S';
                var idUtLote = paramFilial.IDUTILLOTE==='S';
                var fieldLocal = filterWidget.getField("CDLOCALESTOQ");
                var fieldAlmox = filterWidget.getField("CDALMOXARIFE");
                fieldAlmox.readOnly = !idUtAlmox;
                fieldLocal.readOnly = !(idUtAlmox&&idUtLocal);
                fieldAlmox.dataSource.name = (idUtLote) ? "est#/almoxarifado_inverotalote" : "est#/almoxarifado_inverota";
                fieldLocal.dataSource.name = (idUtLote) ? "est#/localestoque_inverotalote" : "est#/localestoque_inverota";
                if (idUtAlmox) {
                    fieldAlmox.validations = {required: true};
                }else{
                    delete fieldAlmox.validations;
                }
                if (idUtLocal) {
                    fieldLocal.validations = {required: true};
                }else{
                    delete fieldLocal.validations;
                }
                filterWidget.getField("NRLOTEESTQ").isVisible = idUtLote;
                filterWidget.getField("NRSUBLOTE").isVisible = idUtLote;
                filterWidget.getField("DTVALILOTE").isVisible = idUtLote;
                
                
                filterWidget.currentRow.CDFILIAL = cdfilial;
                filterWidget.currentRow.DTINVEROTA = dtprocessa;
                filterWidget.currentRow.CDALMOXARIFE = idUtAlmox?null:' ';
                filterWidget.currentRow.CDLOCALESTOQ = (idUtAlmox&&idUtLocal)?null:' ';
                filterWidget.currentRow.UTLOTE = idUtLote;

            });
        }); 
    };
    
    this.openFilter = function(widget, row = {}) {
        this.setFieldsGerais(widget);
        ZhFilterPreferences.setOriginalFilter(widget.id, row);
        return ZhFilterPreferences.openFilterWidget(widget, row);
    };
    
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    this.qtinverotaOnInlineEdit = function(field) {
        if (!field.value()) {
            field.setValue("0.000");
        }
    };

    this.setFilterLocal = function(widget){
        //nao esta senda usada esta funcao
        var row = widget.currentRow;
        var fieldLocal = widget.getField("CDLOCALESTOQ");
        var cdAlmoxarife = row.CDALMOXARIFE;
        fieldLocal.dataSourceFilter[2].value = cdAlmoxarife;
        fieldLocal.readOnlyOnEdit = !cdAlmoxarife;
        fieldLocal.value(fieldLocal.readOnly?" ":null);
    };

    this.montaItemAjuste = function(row){
        var container = templateManager.container;
        var stripe = container.getWidget('stripe');
        var cdalmoxarife = stripe.getField('CDALMOXARIFE').value();
        var cdlocalestoq = stripe.getField('CDLOCALESTOQ').value();
        var cdfilial = stripe.getField('DSFILIAL').value().substr(0,4);
        var dtinverota = stripe.getField('DTPROCESSA').value();
        var newRow = {
            "CDALMOXARIFE": cdalmoxarife,
            "CDFILIAL": cdfilial,
            "CDLOCALESTOQ": cdlocalestoq,
            "CDPRODUTO": row.CDPRODUTO,
            "DTINVEROTA": dtinverota,
            "QTINVEROTA": row.QTINVEROTA,
        };
        return newRow;
    };

    this.save = function(rows,widget){
        var utlote = widget.getField("NRLOTEESTQ").isVisible;
        rows.forEach(function(row){
            row[utlote?"DTINVELOTE":"DTINVEROTA"]  = row.DATA;
            row.QTINVELOTE = row.QTINVEROTA;
        });
        InventarioRotativo_Service.save(rows,utlote).then(function(response){
            widget.commitInlineEdit();
            widget.list();
            this.ajustou = true;
        }.bind(this));
    };



    this.finaliza = function() {
        if(this.ajustou){
            ScreenService.showCustomDialog('Deseja atualizar estoque?', 'question', 'question', [{
                label: ScreenService.i18n("Sim"),
                code: function(){this.chamaProcedure('10');}.bind(this)
            },{
                label: ScreenService.i18n("Não"),
                code: function(){this.chamaProcedure('11');}.bind(this)
            },{
                label: ScreenService.i18n("Zerar"),
                code: function(){this.chamaProcedure('12');}.bind(this)
            }]);

        }else{
            ScreenService.showMessage('Ajuste um produto antes de concluir!');
        }
    };

    this.bloqueiaSaida = function(args){
        if(this.ajustou){
            args.e.preventDefault();
            ScreenService.showMessage("Conclua o lançamento");
        }
        else {
            templateManager.container.validaEstoque = true;
        }
    };

    this.chamaProcedure = function(opcao){
        var container = templateManager.container;
        var lancamento = container.getWidget('Lancamento');
        let widgetFiltro = EstUtil.getFilterWidget(lancamento);
        var filterPopup = lancamento.appliedFilter;

        var cdalmoxarife = widgetFiltro.currentRow.CDALMOXARIFE;
        var cdlocalestoq = widgetFiltro.currentRow.CDLOCALESTOQ;

        var cdfilial = widgetFiltro.currentRow.CDFILIAL;
        var dtprocessa = widgetFiltro.currentRow.DTINVEROTA;
        
        InventarioRotativo_Service.getOperadorLogado().then(function(operador){
            operador = operador[0];
            var cdfilimovi = operador.CDFILIALSELECIONADA;
            var cdoperador = operador.CDOPERADOR;
            var evolestoq;
            if(opcao =='11'){
                evolestoq = 'N';
            }else{
                evolestoq = 'S';
            }

            var filter = [{"name":"EVOLESTOQ","operator":"=","value":evolestoq},
                          {"name":"CDFILIMOVI","operator":"=","value":cdfilimovi},
                          {"name":"CDFILIAL","operator":"=","value":cdfilial},
                          {"name":"CDOPERADOR","operator":"=","value":cdoperador},
                          {"name":"DTPROCESSA","operator":"=","value":dtprocessa.substr(0,10)},
                          {"name":"INOPCAO","operator":"=","value":opcao},
                          {"name":"CDSERVFILI","operator":"=","value":null},
                          {"name":"CDTIPORET","operator":"=","value":null},
                          {"name":"CDCENTCUST","operator":"=","value":null},
                          {"name":"CDSETOR","operator":"=","value":null},
                          {"name":"RETIESTQ","operator":"=","value":"N"},
                          {"name":"CDALMOXARIFE","operator":"=","value":'_'+cdalmoxarife+'_'},
                          {"name":"CDLOCALESTOQ","operator":"=","value":'_'+cdlocalestoq+'_'}];
            InventarioRotativo_Service.atualizaInventarioRotativo(filter).then(function(response){
                var inventarioIsValid = (!!response.dataset) ? response.dataset.AtualizaInveRota[0] : false;
                var message = "";
                if (opcao == '11') {
                    message = 'Operação realizada com sucesso!';
                }
                else {
                    message = 'Estoque atualizado com sucesso!';
                }
                if (inventarioIsValid) {
                    message += "<br />Não há inventário pendente para a unidade.";
                }
                ScreenService.showMessage(ScreenService.i18n(message));
                lancamento.dataSource.data = [];
                lancamento.dataSourceFilter= [];
                filterPopup.FILTER_ROW = {};
                this.ajustou = false;
                this.onEnter();
            }.bind(this),function(error){
                ScreenService.showMessage("ATENÇÃO! A confirmação desta operação fará com que a posição de estoque de um ou mais produtos se torne irregular.",10000);
            });
        }.bind(this));
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger03302_InventarioRotativo_Controller', Ger03302_InventarioRotativo_Controller);
});