var Ger03700_AlmoxarifadoLocalicazao_Controller = function(templateManager, ScreenService, General, restEngine, ZhFilterPreferences) {

    var cdfilialGeral;
    var cdalmoxarifeGeral;

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};

        rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
        rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    }; 

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };



    this.setStripeData = function(row) {
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.NMFILIAL = row.CDFILIAL + " - " + row.NMFILIAL;
    };

    this.retornaParamUnidade = function(cdFilialOpcional) {
        var cdFilialFiltrada = cdFilialOpcional || "FILIAL_LOGADA";
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": cdFilialFiltrada
        }];
        return restEngine.post("est#/crud/paramfilial", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.retornaOperadorLogado = function() {
        var cdOperador = "OPERADOR_LOGADO";
        var filter = [{
            "name": "CDOPERADOR",
            "operator": "=",
            "value": cdOperador
        }];
        return restEngine.post("est#/crud/operador", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.retornaFilialOper = function(operador, filialselecionada) {
        var filter = [{
                "name": "CDOPERADOR",
                "operator": "=",
                "value": operador
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdFilialFiltrada
            }
        ];
        return restEngine.post("est#/crud/filioper", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.onEnterOnce = function(widget) {
        this.openFilter(widget);
    };

    //beforeFilterAply
    this.setVisibleWidgetLocal = function(args) {
        var widget = args.owner,
            currentRowPopup = widget.appliedFilter.FILTER_ROW;
        this.setStripeData(currentRowPopup);
        var cdfilial = currentRowPopup.CDFILIAL;
        cdfilialGeral = cdfilial;
        this.retornaParamUnidade(cdfilial).then(function(paramFilial) {
            var idutilalmox = paramFilial.dataset.paramfilial[0].IDUTILALMOX;
            if (idutilalmox === 'S') {
                var idutillcestq = paramFilial.dataset.paramfilial[0].IDUTILLCESTQ;
                if (idutillcestq === 'S') {
                    widget.widgets[0].isVisible = true;
                    widget.getField('IDCHECK').isVisible = false;
                }
                else {
                    widget.widgets[0].isVisible = false;
                    widget.getField('IDCHECK').isVisible = true;
                }
                var bloqueia = false;
                widget.filtrada = true;
            }
            else {
                setTimeout(function() {
                    ScreenService.showMessage('Unidade selecionada não utiliza controle de almoxarifado.');
                }, 3000);
            }
        }, function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.controlaAlmoxarifado = function(widget) {
        var row = widget.currentRow;
        this.retornaParamUnidade(row.CDFILIAL).then(function(paramFilial) {
            var idutilalmox = paramFilial.dataset.paramfilial[0].IDUTILALMOX;
            if (idutilalmox != 'S') {
                ScreenService.showMessage('Unidade selecionada não utiliza controle de almoxarifado.');
                widget.currentRow.CDFILIAL = '';
                widget.currentRow.NMFILIAL = '';
            }
        });
    };

    //AfterMoveRow
    this.setDataSourceFilterLocal = function(widget) {
        var widgetLocal = widget.widgets[0];
        if (widgetLocal.isVisible === true) {
            var row = widget.currentRow;
            widgetLocal.dataSourceFilter[0].value = row.CDFILIAL;
            widgetLocal.dataSourceFilter[1].value = row.CDALMOXARIFE;
            widgetLocal.reload();
            cdalmoxarifeGeral = row.CDALMOXARIFE;
        }
    };

    //Editar e cancelar da widget principal
    this.setEnabled = function(widget, enabled) {
        if (widget.widgets[0]) {
            widget.widgets[0].enabled = enabled;
        }
    };

    this.deleteAlmoxarifado = function(widget) {
        ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir o almoxarifado e todas as suas localizações?'), 'question', function(success) {
            widget.removeRow(widget.currentRow).then(function(success) {
                ScreenService.closeSwipe();
                widget.reload();
            }, function(error) {
                if (error.data.error) {
                    ScreenService.showMessage("Não é possível excluir. Este almoxarifado está relacionado a outras operações!");
                }
                else {
                    ScreenService.showMessage(error.data);
                }
            });
        });
    };

    this.newAlmoxarifado = function(widget) {
        if (cdfilialGeral === undefined)
            cdfilialGeral = widget.currentRow.CDFILIAL;
        if (cdfilialGeral && widget.filtrada != false) {
            widget.newRow();
            widget.currentRow.CDFILIAL = cdfilialGeral;
            this.setEnabled(widget, false);
        }
        else {
            ScreenService.showMessage("Selecione uma unidade no filtro antes de adicionar.");
        }

    };

    this.newLocalizacao = function(widget) {
        if (cdfilialGeral && widget.filtrada != false) {
            widget.newRow();
            widget.currentRow.CDFILIAL = cdfilialGeral;
            widget.currentRow.CDALMOXARIFE = cdalmoxarifeGeral;
            this.setEnabled(widget, false);
        }
        else {
            ScreenService.showMessage("Selecione uma unidade no filtro antes de adicionar.");
        }
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('Ger03700_AlmoxarifadoLocalicazao_Controller', Ger03700_AlmoxarifadoLocalicazao_Controller);
});
