var Ger27000_LocalEstoqueProduto_Controller = function(ScreenService, EstUtil, templateManager, General,restEngine , Ger27000_LocalEstoqueProduto_Service, ZhFilterPreferences, ZhReports, MessageService) {
	//boolean para o bloqueio da edição de locais
	var fullLocalLock = false;
	var fullLocalLockCad = false;
	//boolean para o bloqueio da edição de almoxarifados
	var fullAlmoxLock = false;
	var fullAlmoxLockCad = false;
	//variavel que guarda o ultimo codigo de filial que passou pela função validadeFilialController
	var previousFilial;

	var filialPad;
	var nmFilial;
	var cdProd;
	var nmProd;

	this.openFilter = function(widget) {
		this.setFieldsGerais(widget);
		var rowsToSet = {};
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
		rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");
		rowsToSet.P_CDPRODINI = null;
		rowsToSet.P_CDPRODFIN = null;
		
		//ZhFilterPreferences.setOriginalFilter(widget.id, rowsToSet);
		ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
			var filtro = widget.container.getActiveWidget();
			this.filiProd(filtro);
		});
	};

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};

	this.getFilial = function() {
		return filialPad;
	};

	//função que checa se a edição de locais e/ou almoxarifados estão bloqueados na filial
	this.validateFilialController = function(widget) {
		var filial;
		var filter;
		if (widget.name !== 'CADASTROAUTOMATICO') {
			if (widget.dataSourceFilter[1]) {
				filial = widget.dataSourceFilter[1].value;
				filter = [{
					"name": "CDFILIAL",
					"operator": "=",
					"value": filial
				}];
			}
		}
		else {
			filial = widget.currentRow.CDFILIAL;
			filter = [{
				"name": "CDFILIAL",
				"operator": "=",
				"value": filial
			}];
		}

		//chamando o backend a partir do service e do repository
		Ger27000_LocalEstoqueProduto_Service.validateFilialService(filter).then(function(success) {
			if (success.dataset.paramfilial[0]) {
				if (success.dataset.paramfilial[0].IDUTILALMOX == 'S') {
					if (widget.name === 'CADASTROAUTOMATICO') {
						fullAlmoxLockCad = false;
					}
					else {
						fullAlmoxLock = false;
					}
					this.almoxLocker(widget);
					if (success.dataset.paramfilial[0].IDUTILLCESTQ == 'S') {
						if (widget.name === 'CADASTROAUTOMATICO') {
							fullAlmoxLockCad = false;
						}
						else {
							fullLocalLock = false;
						}
					}
					else {
						//retorna uma mensagen somente se esta filial for diferente da ultima filial carregada
						if (previousFilial != success.dataset.paramfilial[0].CDFILIAL && previousFilial !== undefined) {
							Ger27000_LocalEstoqueProduto_Service.limpaFieldsCADASTROAUTOMATICO(widget);
							fullLocalLock = true;
							fullLocalLockCad = true;
							this.almoxLocker(widget);
							ScreenService.showMessage("Atenção: Esta Filial está com a edição de Locais bloqueada.");
						}
						if (widget.name === 'CADASTROAUTOMATICO') {
							fullLocalLockCad = true;
						}
						else {
							fullLocalLock = true;
						}
					}
				}
				else {
					//retorna uma mensagen somente se esta filial for diferente da ultima filial carregada
					if (previousFilial != success.dataset.paramfilial[0].CDFILIAL) {
						Ger27000_LocalEstoqueProduto_Service.limpaFieldsCADASTROAUTOMATICO(widget);
						fullLocalLock = true;
						fullLocalLockCad = true;
						this.almoxLocker(widget);
						ScreenService.showMessage("Atenção: Esta Filial está com a edição de Almoxarifados bloqueada.");
					}
					if (widget.name === 'CADASTROAUTOMATICO') {
						fullAlmoxLockCad = true;
					}
					else {
						fullAlmoxLock = true;
					}
					this.almoxLocker(widget);
				}
				previousFilial = success.dataset.paramfilial[0].CDFILIAL;
			}
		}.bind(this));
	};

	this.setFormCurrentRow = function(widget) {
		widget.currentRow = widget.dataSource.data[0];
		this.setColorLegenda(widget.getParent());
	};

	var getZ = function() {
		var numFormatado = "";
		var num = getLocalVar("CDPICTPROD");
		var zAux = "z";
		num = num.replace("*", "");
		// TODO: trocar for por replace. (replace não funcionou com ponto final (.).
		for (var i = 0; i < num.length; i++) {
			if (num[i] != ".") {
				numFormatado += num[i];
			}
		}
		return zAux.repeat(numFormatado.length);
	};

	this.ajustaFiltro = function(args) {
		var widget = args.owner;
		var filtros = args.e.preference.FILTER_ROW;
		if (filtros.P_CDPRODINI && filtros.P_CDPRODFIN) {
			widget.dataSourceFilter.forEach(function(data) {
				if (data.name == "P_CDPRODINI") {
					data.value = filtros.P_CDPRODINI;
				}
				else if (data.name == "P_CDPRODFIN") {
					data.value = filtros.P_CDPRODFIN + getZ();
				}

			});
		}
	};

	//função responsável por bloquear e desbloquear a edição de almoxarifados
	this.almoxLocker = function(widgetPai) {
		//widgetPai.widgets.forEach(widgetPai => {
		//	widFilha.getField('')
		if (widgetPai.name !== 'CADASTROAUTOMATICO' || widgetPai.appliedFilter) {
			var currentRowPopup = widgetPai.appliedFilter.FILTER_ROW;
			var widgetControle = templateManager.container.getWidget('CONTROLEPRODUCAO');
			var widgetPedidos = templateManager.container.getWidget('PEDIDOSEXPEDICAO');
			var widgetControleQualidade = templateManager.container.getWidget('CONTROLEQUALIDADE');
			var widgetGestaoVendas = templateManager.container.getWidget('GESTAODEVENDAS');
			widgetControle.getField('DSALMOXINSPR').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControle.getField('DSALMOXPRSEMACA').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControle.getField('DSALMOXINSPRPIL').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControle.getField('DSALPROD').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControle.getField('DSALPRODPIL').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControle.getField('DSALMOXPRACA').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetPedidos.getField('DSALMOXPRCLI').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControleQualidade.getField('DSALMOXARIFE').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControleQualidade.getField('DSALMOXQUAMPPIL').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControleQualidade.getField('DSALMOXQUAR').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControleQualidade.getField('DSALMOXREPROV').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetGestaoVendas.getField('DSALMOXCONSVND').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetGestaoVendas.getField('DSLOCALCONSVND').dataSourceFilter[0].value = currentRowPopup.CDFILIAL;
			widgetControle.getField('DSALMOXINSPR').reload();
			widgetControle.getField('DSALMOXPRSEMACA').reload();
			widgetControle.getField('DSALMOXINSPRPIL').reload();
			widgetControle.getField('DSALPROD').reload();
			widgetControle.getField('DSALPRODPIL').reload();
			widgetControle.getField('DSALMOXPRACA').reload();
			widgetPedidos.getField('DSALMOXPRCLI').reload();
			widgetControleQualidade.getField('DSALMOXARIFE').reload();
			widgetControleQualidade.getField('DSALMOXQUAMPPIL').reload();
			widgetControleQualidade.getField('DSALMOXQUAR').reload();
			widgetControleQualidade.getField('DSALMOXREPROV').reload();
			widgetGestaoVendas.getField('DSALMOXCONSVND').reload();
			widgetGestaoVendas.getField('DSLOCALCONSVND').reload();
			if (fullAlmoxLock) {
				//1
				widgetControle.currentRow.DSALMOXINSPR = '';
				widgetControle.getField('DSALMOXINSPR').readOnly = true;
				widgetControle.getField('DSALMOXINSPR').readOnlyOnEdit = true;
				widgetControle.getField('DSLOCALINSPR').readOnly = true;
				widgetControle.getField('DSLOCALINSPR').readOnlyOnEdit = true;
				//2
				widgetControle.currentRow.DSALMOXPRSEMACA = '';
				widgetControle.getField('DSALMOXPRSEMACA').readOnly = true;
				widgetControle.getField('DSALMOXPRSEMACA').readOnlyOnEdit = true;
				widgetControle.getField('DSLOCALPRSEMACA').readOnly = true;
				widgetControle.getField('DSLOCALPRSEMACA').readOnlyOnEdit = true;
				//3
				widgetControle.currentRow.DSALMOXINSPRPIL = '';
				widgetControle.getField('DSALMOXINSPRPIL').readOnly = true;
				widgetControle.getField('DSALMOXINSPRPIL').readOnlyOnEdit = true;
				widgetControle.getField('DSLOCALINSPRPIL').readOnly = true;
				widgetControle.getField('DSLOCALINSPRPIL').readOnlyOnEdit = true;
				//4
				widgetControle.currentRow.DSALPROD = '';
				widgetControle.getField('DSALPROD').readOnly = true;
				widgetControle.getField('DSALPROD').readOnlyOnEdit = true;
				widgetControle.getField('DSLOCPROD').readOnly = true;
				widgetControle.getField('DSLOCPROD').readOnlyOnEdit = true;
				//5
				widgetControle.currentRow.DSALPRODPIL = '';
				widgetControle.getField('DSALPRODPIL').readOnly = true;
				widgetControle.getField('DSALPRODPIL').readOnlyOnEdit = true;
				widgetControle.getField('DSLOCPRODPRIL').readOnly = true;
				widgetControle.getField('DSLOCPRODPRIL').readOnlyOnEdit = true;
				//6
				widgetControle.currentRow.DSALMOXPRACA = '';
				widgetControle.getField('DSALMOXPRACA').readOnly = true;
				widgetControle.getField('DSALMOXPRACA').readOnlyOnEdit = true;
				widgetControle.getField('DSLOCALPRACA').readOnly = true;
				widgetControle.getField('DSLOCALPRACA').readOnlyOnEdit = true;
				//7
				widgetPedidos.currentRow.DSALMOXPRCLI = '';
				widgetPedidos.getField('DSALMOXPRCLI').readOnly = true;
				widgetPedidos.getField('DSALMOXPRCLI').readOnlyOnEdit = true;
				widgetPedidos.getField('DSLOCALPRCLI').readOnly = true;
				widgetPedidos.getField('DSLOCALPRCLI').readOnlyOnEdit = true;
				//8
				widgetControleQualidade.currentRow.DSALMOXARIFE = '';
				widgetControleQualidade.getField('DSALMOXARIFE').readOnly = true;
				widgetControleQualidade.getField('DSALMOXARIFE').readOnlyOnEdit = true;
				widgetControleQualidade.getField('DSLOCALESTOQ').readOnly = true;
				widgetControleQualidade.getField('DSLOCALESTOQ').readOnlyOnEdit = true;
				//9
				widgetControleQualidade.currentRow.DSALMOXQUAMPPIL = '';
				widgetControleQualidade.getField('DSALMOXQUAMPPIL').readOnly = true;
				widgetControleQualidade.getField('DSALMOXQUAMPPIL').readOnlyOnEdit = true;
				widgetControleQualidade.getField('DSLOCALQUAMPPIL').readOnly = true;
				widgetControleQualidade.getField('DSLOCALQUAMPPIL').readOnlyOnEdit = true;
				//10
				widgetControleQualidade.currentRow.DSALMOXQUAR = '';
				widgetControleQualidade.getField('DSALMOXQUAR').readOnly = true;
				widgetControleQualidade.getField('DSALMOXQUAR').readOnlyOnEdit = true;
				widgetControleQualidade.getField('DSLOCALQUAR').readOnly = true;
				widgetControleQualidade.getField('DSLOCALQUAR').readOnlyOnEdit = true;
				//11
				widgetControleQualidade.currentRow.DSALMOXREPROV = '';
				widgetControleQualidade.getField('DSALMOXREPROV').readOnly = true;
				widgetControleQualidade.getField('DSALMOXREPROV').readOnlyOnEdit = true;
				widgetControleQualidade.getField('DSLOCALREPROV').readOnly = true;
				widgetControleQualidade.getField('DSLOCALREPROV').readOnlyOnEdit = true;
				//12
				widgetGestaoVendas.currentRow.DSALMOXCONSVND = '';
				widgetGestaoVendas.getField('DSALMOXCONSVND').readOnly = true;
				widgetGestaoVendas.getField('DSALMOXCONSVND').readOnlyOnEdit = true;
				widgetGestaoVendas.getField('DSLOCALCONSVND').readOnly = true;
				widgetGestaoVendas.getField('DSLOCALCONSVND').readOnlyOnEdit = true;
			}
			else {
				//1
				widgetControle.currentRow.DSALMOXINSPR = '';
				widgetControle.getField('DSALMOXINSPR').readOnly = false;
				widgetControle.getField('DSALMOXINSPR').readOnlyOnEdit = false;
				//2
				widgetControle.currentRow.DSALMOXPRSEMACA = '';
				widgetControle.getField('DSALMOXPRSEMACA').readOnly = false;
				widgetControle.getField('DSALMOXPRSEMACA').readOnlyOnEdit = false;
				//3
				widgetControle.currentRow.LMOXINSPRPIL = '';
				widgetControle.getField('DSALMOXINSPRPIL').readOnly = false;
				widgetControle.getField('DSALMOXINSPRPIL').readOnlyOnEdit = false;
				//4
				widgetControle.currentRow.DSALPROD = '';
				widgetControle.getField('DSALPROD').readOnly = false;
				widgetControle.getField('DSALPROD').readOnlyOnEdit = false;
				//5
				widgetControle.currentRow.DSALPRODPIL = '';
				widgetControle.getField('DSALPRODPIL').readOnly = false;
				widgetControle.getField('DSALPRODPIL').readOnlyOnEdit = false;
				//6
				widgetControle.currentRow.DSALMOXPRACA = '';
				widgetControle.getField('DSALMOXPRACA').readOnly = false;
				widgetControle.getField('DSALMOXPRACA').readOnlyOnEdit = false;
				//7
				widgetPedidos.currentRow.DSALMOXPRCLI = '';
				widgetPedidos.getField('DSALMOXPRCLI').readOnly = false;
				widgetPedidos.getField('DSALMOXPRCLI').readOnlyOnEdit = false;
				//8
				widgetControleQualidade.currentRow.DSALMOXARIFE = '';
				widgetControleQualidade.getField('DSALMOXARIFE').readOnly = false;
				widgetControleQualidade.getField('DSALMOXARIFE').readOnlyOnEdit = false;
				//9
				widgetControleQualidade.currentRow.DSALMOXQUAMPPIL = '';
				widgetControleQualidade.getField('DSALMOXQUAMPPIL').readOnly = false;
				widgetControleQualidade.getField('DSALMOXQUAMPPIL').readOnlyOnEdit = false;
				//10
				widgetControleQualidade.currentRow.DSALMOXQUAR = '';
				widgetControleQualidade.getField('DSALMOXQUAR').readOnly = false;
				widgetControleQualidade.getField('DSALMOXQUAR').readOnlyOnEdit = false;
				//11
				widgetControleQualidade.currentRow.DSALMOXREPROV = '';
				widgetControleQualidade.getField('DSALMOXREPROV').readOnly = false;
				widgetControleQualidade.getField('DSALMOXREPROV').readOnlyOnEdit = false;
				//12
				widgetGestaoVendas.currentRow.DSALMOXCONSVND = '';
				widgetGestaoVendas.getField('DSALMOXCONSVND').readOnly = false;
				widgetGestaoVendas.getField('DSALMOXCONSVND').readOnlyOnEdit = false;
			}
			//});
		}
		else {
				widgetPai.getField('DSALMOXINSPR').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXPRSEMACA').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXINSPRPIL').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALPROD').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALPRODPIL').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXPRACA').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXPRCLI').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXARIFE').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXQUAMPPIL').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXQUAR').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXREPROV').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXCONSVND').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSLOCALCONSVND').dataSourceFilter[0].value = widgetPai.currentRow.CDFILIAL;
				widgetPai.getField('DSALMOXINSPR').reload();
				widgetPai.getField('DSALMOXPRSEMACA').reload();
				widgetPai.getField('DSALMOXINSPRPIL').reload();
				widgetPai.getField('DSALPROD').reload();
				widgetPai.getField('DSALPRODPIL').reload();
				widgetPai.getField('DSALMOXPRACA').reload();
				widgetPai.getField('DSALMOXPRCLI').reload();
				widgetPai.getField('DSALMOXARIFE').reload();
				widgetPai.getField('DSALMOXQUAMPPIL').reload();
				widgetPai.getField('DSALMOXQUAR').reload();
				widgetPai.getField('DSALMOXREPROV').reload();
				widgetPai.getField('DSALMOXCONSVND').reload();
				widgetPai.getField('DSLOCALCONSVND').reload();
	
				if (fullAlmoxLockCad) {
					//1
					widgetPai.currentRow.DSALMOXINSPR = '';
					widgetPai.getField('DSALMOXINSPR').readOnly = true;
					widgetPai.getField('DSALMOXINSPR').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALINSPR').readOnly = true;
					widgetPai.getField('DSLOCALINSPR').readOnlyOnEdit = true;
					//2
					widgetPai.currentRow.DSALMOXPRSEMACA = '';
					widgetPai.getField('DSALMOXPRSEMACA').readOnly = true;
					widgetPai.getField('DSALMOXPRSEMACA').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALPRSEMACA').readOnly = true;
					widgetPai.getField('DSLOCALPRSEMACA').readOnlyOnEdit = true;
					//3
					widgetPai.currentRow.DSALMOXINSPRPIL = '';
					widgetPai.getField('DSALMOXINSPRPIL').readOnly = true;
					widgetPai.getField('DSALMOXINSPRPIL').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALINSPRPIL').readOnly = true;
					widgetPai.getField('DSLOCALINSPRPIL').readOnlyOnEdit = true;
					//4
					widgetPai.currentRow.DSALPROD = '';
					widgetPai.getField('DSALPROD').readOnly = true;
					widgetPai.getField('DSALPROD').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCPROD').readOnly = true;
					widgetPai.getField('DSLOCPROD').readOnlyOnEdit = true;
					//5
					widgetPai.currentRow.DSALPRODPIL = '';
					widgetPai.getField('DSALPRODPIL').readOnly = true;
					widgetPai.getField('DSALPRODPIL').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCPRODPRIL').readOnly = true;
					widgetPai.getField('DSLOCPRODPRIL').readOnlyOnEdit = true;
					//6
					widgetPai.currentRow.DSALMOXPRACA = '';
					widgetPai.getField('DSALMOXPRACA').readOnly = true;
					widgetPai.getField('DSALMOXPRACA').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALPRACA').readOnly = true;
					widgetPai.getField('DSLOCALPRACA').readOnlyOnEdit = true;
					//7
					widgetPai.currentRow.DSALMOXPRCLI = '';
					widgetPai.getField('DSALMOXPRCLI').readOnly = true;
					widgetPai.getField('DSALMOXPRCLI').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALPRCLI').readOnly = true;
					widgetPai.getField('DSLOCALPRCLI').readOnlyOnEdit = true;
					//8
					widgetPai.currentRow.DSALMOXARIFE = '';
					widgetPai.getField('DSALMOXARIFE').readOnly = true;
					widgetPai.getField('DSALMOXARIFE').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALESTOQ').readOnly = true;
					widgetPai.getField('DSLOCALESTOQ').readOnlyOnEdit = true;
					//9
					widgetPai.currentRow.DSALMOXQUAMPPIL = '';
					widgetPai.getField('DSALMOXQUAMPPIL').readOnly = true;
					widgetPai.getField('DSALMOXQUAMPPIL').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALQUAMPPIL').readOnly = true;
					widgetPai.getField('DSLOCALQUAMPPIL').readOnlyOnEdit = true;
					//10
					widgetPai.currentRow.DSALMOXQUAR = '';
					widgetPai.getField('DSALMOXQUAR').readOnly = true;
					widgetPai.getField('DSALMOXQUAR').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALQUAR').readOnly = true;
					widgetPai.getField('DSLOCALQUAR').readOnlyOnEdit = true;
					//11
					widgetPai.currentRow.DSALMOXREPROV = '';
					widgetPai.getField('DSALMOXREPROV').readOnly = true;
					widgetPai.getField('DSALMOXREPROV').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALREPROV').readOnly = true;
					widgetPai.getField('DSLOCALREPROV').readOnlyOnEdit = true;
					//12
					widgetPai.currentRow.DSALMOXCONSVND = '';
					widgetPai.getField('DSALMOXCONSVND').readOnly = true;
					widgetPai.getField('DSALMOXCONSVND').readOnlyOnEdit = true;
					widgetPai.getField('DSLOCALCONSVND').readOnly = true;
					widgetPai.getField('DSLOCALCONSVND').readOnlyOnEdit = true;
				}
				else {
					//1
					widgetPai.currentRow.DSALMOXINSPR = '';
					widgetPai.getField('DSALMOXINSPR').readOnly = false;
					widgetPai.getField('DSALMOXINSPR').readOnlyOnEdit = false;
					//2
					widgetPai.currentRow.DSALMOXPRSEMACA = '';
					widgetPai.getField('DSALMOXPRSEMACA').readOnly = false;
					widgetPai.getField('DSALMOXPRSEMACA').readOnlyOnEdit = false;
					//3
					widgetPai.currentRow.DSALMOXINSPRPIL = '';
					widgetPai.getField('DSALMOXINSPRPIL').readOnly = false;
					widgetPai.getField('DSALMOXINSPRPIL').readOnlyOnEdit = false;
					//4
					widgetPai.currentRow.DSALPROD = '';
					widgetPai.getField('DSALPROD').readOnly = false;
					widgetPai.getField('DSALPROD').readOnlyOnEdit = false;
					//5
					widgetPai.currentRow.DSALPRODPIL = '';
					widgetPai.getField('DSALPRODPIL').readOnly = false;
					widgetPai.getField('DSALPRODPIL').readOnlyOnEdit = false;
					//6
					widgetPai.currentRow.DSALMOXPRACA = '';
					widgetPai.getField('DSALMOXPRACA').readOnly = false;
					widgetPai.getField('DSALMOXPRACA').readOnlyOnEdit = false;
					//7
					widgetPai.currentRow.DSALMOXPRCLI = '';
					widgetPai.getField('DSALMOXPRCLI').readOnly = false;
					widgetPai.getField('DSALMOXPRCLI').readOnlyOnEdit = false;
					//8
					widgetPai.currentRow.DSALMOXARIFE = '';
					widgetPai.getField('DSALMOXARIFE').readOnly = false;
					widgetPai.getField('DSALMOXARIFE').readOnlyOnEdit = false;
					//9
					widgetPai.currentRow.DSALMOXQUAMPPIL = '';
					widgetPai.getField('DSALMOXQUAMPPIL').readOnly = false;
					widgetPai.getField('DSALMOXQUAMPPIL').readOnlyOnEdit = false;
					//10
					widgetPai.currentRow.DSALMOXQUAR = '';
					widgetPai.getField('DSALMOXQUAR').readOnly = false;
					widgetPai.getField('DSALMOXQUAR').readOnlyOnEdit = false;
					//11
					widgetPai.currentRow.DSALMOXREPROV = '';
					widgetPai.getField('DSALMOXREPROV').readOnly = false;
					widgetPai.getField('DSALMOXREPROV').readOnlyOnEdit = false;
					//12
					widgetPai.currentRow.DSALMOXCONSVND = '';
					widgetPai.getField('DSALMOXCONSVND').readOnly = false;
					widgetPai.getField('DSALMOXCONSVND').readOnlyOnEdit = false;
				}
			
		}


		//	

	};

	//função responsável por limitar a seleção do produto inicial a partir do filial
	this.filiProd = function(widget) {
		var row = widget.currentRow;
		var filialIsSet = this.fieldIsSet(row.CDFILIAL);
		if (filialIsSet && widget.name === 'CADASTROAUTOMATICO') {
			this.validateFilialController(widget);
		}
		if (!filialIsSet) {
			Ger27000_LocalEstoqueProduto_Service.limpaFieldsCADASTROAUTOMATICO(widget);
			fullAlmoxLockCad = true;
			fullLocalLockCad = true;
			this.almoxLocker(widget);
			widget.currentRow.NMPRODINI = '';
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.P_CDPRODINI = '';
			widget.currentRow.P_CDPRODFIN = '';
			delete widget.getField('NMPRODINI').validations.required;
			delete widget.getField('NMPRODFIN').validations.required;
			widget.getField('NMPRODINI').readOnly = true;
			widget.getField('NMPRODINI').readOnlyOnEdit = true;
			widget.getField('NMPRODFIN').readOnly = true;
			widget.getField('NMPRODFIN').readOnlyOnEdit = true;
		} 
		if (row.NMFILIAL && (row.NMFILIAL != "")) {
			widget.getField('NMPRODINI').dataSourceFilter.forEach(function(fil) {
				if (fil.name === 'CDFILIAL') {
					fil.value = widget.currentRow.CDFILIAL;
				}
			});
			widget.getField('NMPRODFIN').dataSourceFilter.forEach(function(fil) {
				if (fil.name === 'CDFILIAL') {
					fil.value = widget.currentRow.CDFILIAL;
				}
			});
		}
		widget.getField('NMPRODINI').reload();
		widget.getField('NMPRODFIN').reload();
		if(widget.name === 'CADASTROAUTOMATICO') {
			if(filialIsSet) {
				widget.getField('NMPRODINI').validations.required = true;
				widget.getField('NMPRODINI').readOnly = false;
				widget.getField('NMPRODINI').readOnlyOnEdit = false;
				delete widget.getField('NMPRODFIN').validations.required;
				widget.getField('NMPRODFIN').readOnly = true;
				widget.getField('NMPRODFIN').readOnlyOnEdit = true;
			} else {
				delete widget.getField('NMPRODINI').validations.required;
				widget.getField('NMPRODINI').readOnly = true;
				widget.getField('NMPRODINI').readOnlyOnEdit = true;
				delete widget.getField('NMPRODFIN').validations.required;
				widget.getField('NMPRODFIN').readOnly = true;
				widget.getField('NMPRODFIN').readOnlyOnEdit = true;
			}
		} else {
			widget.getField('NMPRODINI').readOnly = false;
			widget.getField('NMPRODINI').readOnlyOnEdit = false;
		}
		widget.getField('NMPRODINI').reload();
		widget.getField('NMPRODFIN').reload();
	};

	this.FilterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if (!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.P_CDPRODFIN = '';
			if (widget.name === 'widgetProduto' || widget.name === 'zhFilterPreferencesSelectConditions') {
				delete widget.getField('NMPRODINI').validations.required;
				delete widget.getField('NMPRODFIN').validations.required;
			}
		}
		else if (widget.name === 'widgetProduto' || widget.name === 'zhFilterPreferencesSelectConditions') {
			widget.getField('NMPRODFIN').validations.required = true;
		}
		
		widget.getField('NMPRODFIN').readOnly = !prodIniIsSet;
		widget.getField('NMPRODFIN').readOnlyOnEdit = !prodIniIsSet;

		if (!prodIniIsSet)
			delete widget.getField('NMPRODFIN').validations.required;
		else
			widget.getField('NMPRODFIN').validations.required = prodIniIsSet;
	};

	this.fieldIsSet = function(fieldValue) {
		if (fieldValue) return true;
		else return false;
	};

	this.FilterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = this.fieldIsSet(row.P_CDPRODFIN);
		var prodIniIsSet = this.fieldIsSet(row.P_CDPRODINI);
		if (prodFinIsSet) {
			if (widget.name === 'widgetProduto' || widget.name === 'zhFilterPreferencesSelectConditions') {
				widget.getField('NMPRODINI').validations.required = true;
			}
			if (row.P_CDPRODINI > row.P_PRODFIN) {
				ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
				return 0;
			}
		}
		else if (widget.name === 'widgetProduto' || widget.name === 'zhFilterPreferencesSelectConditions') {
			delete widget.getField('NMPRODINI').validations.required;
			if (!prodIniIsSet) {
				delete widget.getField('NMPRODFIN').validations.required;
			}
		}
		widget.reload();
	};

	this.setColorLegenda = function(widget) {
		var widgetControle = templateManager.container.getWidget('TABBEDCONTROLEPRODUCAO');
		var widgetPedidos = templateManager.container.getWidget('TABBEDPEDIDOS');
		var widgetControleQualidade = templateManager.container.getWidget('TABBEDCONTROLEQUALIDADE');
		var widgetGestaoVendas = templateManager.container.getWidget('TABBEDGESTAODEVENDAS');
		var obj;
		// Campos Legenda Controle de produção
		if (widget.name === 'TABBEDCONTROLEPRODUCAO') {
			var rowControle = {
				LEGALMOXMATP: tinycolor('#007f80'),
				LEGALMOXPRODS: tinycolor('#007f80'),
				LEGALMOXMATPP1: tinycolor('#800000'),
				LEGALMOXMATPP2: tinycolor('#007f80'),
				LEGALMOXMATPI: tinycolor('#800000'),
				LEGALMOXMATPPI1: tinycolor('#800000'),
				LEGALMOXMATPPI2: tinycolor('#808000'),
				LEGALMOXPRODA: tinycolor('#000080')
			};
			if (widgetControle.widgets[0].currentRow) {
				obj = Object.assign(widgetControle.widgets[0].currentRow, rowControle);
				widgetControle.widgets[0].currentRow = obj;
			}
			else {
				widgetControle.widgets[0].currentRow = rowControle;
			}
		}
		else if (widget.name === 'TABBEDPEDIDOS') {
			var rowPedidos = {
				LEGALMOXEXPRE: tinycolor('#000080')
			};
			if (widgetPedidos.widgets[0].currentRow) {
				obj = Object.assign(widgetPedidos.widgets[0].currentRow, rowPedidos);
				widgetPedidos.widgets[0].currentRow = obj;
			}
			else {
				widgetPedidos.widgets[0].currentRow = rowPedidos;
			}
		}

		else if (widget.name === 'TABBEDCONTROLEQUALIDADE') {
			var rowControleQualidade = {
				LEGALMOXQMI: tinycolor('#99B4D1'),
				LEGALMOXQMP1: tinycolor('#800000'),
				LEGALMOXQMP2: tinycolor('#99B4D1'),
				LEGALMOXQPA: tinycolor('#99B4D1'),
				LEGALMOXREPROV: tinycolor('#FF0000')
			};
			if (widgetControleQualidade.widgets[0].currentRow) {
				obj = Object.assign(widgetControleQualidade.widgets[0].currentRow, rowControleQualidade);
				widgetControleQualidade.widgets[0].currentRow = obj;
			}
			else {
				widgetControleQualidade.widgets[0].currentRow = rowControleQualidade;
			}
		}
		else if (widget.name === 'TABBEDGESTAODEVENDAS'){
			var rowGestaoVendas = {};
			if (widgetGestaoVendas.widgets[0].currentRow) {
				obj = Object.assign(widgetGestaoVendas.widgets[0].currentRow, rowGestaoVendas);
				widgetGestaoVendas.widgets[0].currentRow = obj;
			}
			else {
				widgetGestaoVendas.widgets[0].currentRow = rowGestaoVendas;
			}
		}

		//Legenda padrão
		var rowLegenda = {
			VINHO: tinycolor('#800000'),
			VERDEAGUA: tinycolor('#008080'),
			AZULCLARO: tinycolor('#99B4D1'),
			BEGE: tinycolor('#808000'),
			AZULESCURO: tinycolor('#000080'),
			VERMELHO: tinycolor('#FF0000')
		};
		widgetControle.currentRow = rowLegenda;
		widgetPedidos.currentRow = rowLegenda;
		widgetControleQualidade.currentRow = rowLegenda;
		widgetGestaoVendas.currentRow = rowLegenda;




	};

	//função default para retornar o valor de um campo
	this.setFieldsAddress = function(widgetName, fieldName) {
		return General.getFieldValue(fieldName, widgetName);
	};

	//função responsável por recarregar campos que sofreram mudanças
	this.reloadWidget = function(args, fieldName) {
		var field = args.owner.field.widget.getField(fieldName);
		field.reload();
	};

	/*função responsável por bloquear/desbloquear os campos de local caso o campo
	de almoxarifado correspondente esteja preenchido*/
	this.localLock = function(args, number) {
		var widget = args.owner.field.widget;
		var row;
		if (widget.name === 'CADASTROAUTOMATICO') {
			if (!fullLocalLockCad) {
				row = args.owner.field.widget.currentRow;

				switch (number) {
					case 1:
						args.owner.field.widget.currentRow.DSLOCALINSPR = '';
						args.owner.field.widget.getField('DSLOCALINSPR').readOnly = !row.DSALMOXINSPR;
						args.owner.field.widget.getField('DSLOCALINSPR').readOnlyOnEdit = !row.DSALMOXINSPR;
						break;
					case 2:
						args.owner.field.widget.currentRow.DSLOCALPRSEMACA = '';
						args.owner.field.widget.getField('DSLOCALPRSEMACA').readOnly = !row.DSALMOXPRSEMACA;
						args.owner.field.widget.getField('DSLOCALPRSEMACA').readOnlyOnEdit = !row.DSALMOXPRSEMACA;
						break;
					case 3:
						args.owner.field.widget.currentRow.DSLOCALINSPRPIL = '';
						args.owner.field.widget.getField('DSLOCALINSPRPIL').readOnly = !row.DSALMOXINSPRPIL;
						args.owner.field.widget.getField('DSLOCALINSPRPIL').readOnlyOnEdit = !row.DSALMOXINSPRPIL;
						break;
					case 4:
						args.owner.field.widget.currentRow.DSLOCPROD = '';
						args.owner.field.widget.getField('DSLOCPROD').readOnly = !row.DSALPROD;
						args.owner.field.widget.getField('DSLOCPROD').readOnlyOnEdit = !row.DSALPROD;
						break;
					case 5:
						args.owner.field.widget.currentRow.DSLOCPRODPRIL = '';
						args.owner.field.widget.getField('DSLOCPRODPRIL').readOnly = !row.DSALPRODPIL;
						args.owner.field.widget.getField('DSLOCPRODPRIL').readOnlyOnEdit = !row.DSALPRODPIL;
						break;
					case 6:
						args.owner.field.widget.currentRow.DSLOCALPRACA = '';
						args.owner.field.widget.getField('DSLOCALPRACA').readOnly = !row.DSALMOXPRACA;
						args.owner.field.widget.getField('DSLOCALPRACA').readOnlyOnEdit = !row.DSALMOXPRACA;
						break;
					case 7:
						args.owner.field.widget.currentRow.DSLOCALPRCLI = '';
						args.owner.field.widget.getField('DSLOCALPRCLI').readOnly = !row.DSALMOXPRCLI;
						args.owner.field.widget.getField('DSLOCALPRCLI').readOnlyOnEdit = !row.DSALMOXPRCLI;
						break;
					case 8:
						args.owner.field.widget.currentRow.DSLOCALESTOQ = '';
						args.owner.field.widget.getField('DSLOCALESTOQ').readOnly = !row.DSALMOXARIFE;
						args.owner.field.widget.getField('DSLOCALESTOQ').readOnlyOnEdit = !row.DSALMOXARIFE;
						break;
					case 9:
						args.owner.field.widget.currentRow.DSLOCALQUAMPPIL = '';
						args.owner.field.widget.getField('DSLOCALQUAMPPIL').readOnly = !row.DSALMOXQUAMPPIL;
						args.owner.field.widget.getField('DSLOCALQUAMPPIL').readOnlyOnEdit = !row.DSALMOXQUAMPPIL;
						break;
					case 10:
						args.owner.field.widget.currentRow.DSLOCALQUAR = '';
						args.owner.field.widget.getField('DSLOCALQUAR').readOnly = !row.DSALMOXQUAR;
						args.owner.field.widget.getField('DSLOCALQUAR').readOnlyOnEdit = !row.DSALMOXQUAR;
						break;
					case 11:
						args.owner.field.widget.currentRow.DSLOCALREPROV = '';
						args.owner.field.widget.getField('DSLOCALREPROV').readOnly = !row.DSALMOXREPROV;
						args.owner.field.widget.getField('DSLOCALREPROV').readOnlyOnEdit = !row.DSALMOXREPROV;
						break;
					case 12:
						args.owner.field.widget.currentRow.DSLOCALCONSVND = '';
						args.owner.field.widget.getField('DSLOCALCONSVND').readOnly = !row.DSALMOXCONSVND;
						args.owner.field.widget.getField('DSLOCALCONSVND').readOnlyOnEdit = !row.DSALMOXCONSVND;
						break;
				}

			}
		}
		else {
			if (!fullLocalLock) {
				row = args.owner.field.widget.currentRow;

				switch (number) {
					case 1:
						args.owner.field.widget.currentRow.DSLOCALINSPR = '';
						args.owner.field.widget.getField('DSLOCALINSPR').readOnly = !row.DSALMOXINSPR;
						args.owner.field.widget.getField('DSLOCALINSPR').readOnlyOnEdit = !row.DSALMOXINSPR;
						break;
					case 2:
						args.owner.field.widget.currentRow.DSLOCALPRSEMACA = '';
						args.owner.field.widget.getField('DSLOCALPRSEMACA').readOnly = !row.DSALMOXPRSEMACA;
						args.owner.field.widget.getField('DSLOCALPRSEMACA').readOnlyOnEdit = !row.DSALMOXPRSEMACA;
						break;
					case 3:
						args.owner.field.widget.currentRow.DSLOCALINSPRPIL = '';
						args.owner.field.widget.getField('DSLOCALINSPRPIL').readOnly = !row.DSALMOXINSPRPIL;
						args.owner.field.widget.getField('DSLOCALINSPRPIL').readOnlyOnEdit = !row.DSALMOXINSPRPIL;
						break;
					case 4:
						args.owner.field.widget.currentRow.DSLOCPROD = '';
						args.owner.field.widget.getField('DSLOCPROD').readOnly = !row.DSALPROD;
						args.owner.field.widget.getField('DSLOCPROD').readOnlyOnEdit = !row.DSALPROD;
						break;
					case 5:
						args.owner.field.widget.currentRow.DSLOCPRODPRIL = '';
						args.owner.field.widget.getField('DSLOCPRODPRIL').readOnly = !row.DSALPRODPIL;
						args.owner.field.widget.getField('DSLOCPRODPRIL').readOnlyOnEdit = !row.DSALPRODPIL;
						break;
					case 6:
						args.owner.field.widget.currentRow.DSLOCALPRACA = '';
						args.owner.field.widget.getField('DSLOCALPRACA').readOnly = !row.DSALMOXPRACA;
						args.owner.field.widget.getField('DSLOCALPRACA').readOnlyOnEdit = !row.DSALMOXPRACA;
						break;
					case 7:
						args.owner.field.widget.currentRow.DSLOCALPRCLI = '';
						args.owner.field.widget.getField('DSLOCALPRCLI').readOnly = !row.DSALMOXPRCLI;
						args.owner.field.widget.getField('DSLOCALPRCLI').readOnlyOnEdit = !row.DSALMOXPRCLI;
						break;
					case 8:
						args.owner.field.widget.currentRow.DSLOCALESTOQ = '';
						args.owner.field.widget.getField('DSLOCALESTOQ').readOnly = !row.DSALMOXARIFE;
						args.owner.field.widget.getField('DSLOCALESTOQ').readOnlyOnEdit = !row.DSALMOXARIFE;
						break;
					case 9:
						args.owner.field.widget.currentRow.DSLOCALQUAMPPIL = '';
						args.owner.field.widget.getField('DSLOCALQUAMPPIL').readOnly = !row.DSALMOXQUAMPPIL;
						args.owner.field.widget.getField('DSLOCALQUAMPPIL').readOnlyOnEdit = !row.DSALMOXQUAMPPIL;
						break;
					case 10:
						args.owner.field.widget.currentRow.DSLOCALQUAR = '';
						args.owner.field.widget.getField('DSLOCALQUAR').readOnly = !row.DSALMOXQUAR;
						args.owner.field.widget.getField('DSLOCALQUAR').readOnlyOnEdit = !row.DSALMOXQUAR;
						break;
					case 11:
						args.owner.field.widget.currentRow.DSLOCALREPROV = '';
						args.owner.field.widget.getField('DSLOCALREPROV').readOnly = !row.DSALMOXREPROV;
						args.owner.field.widget.getField('DSLOCALREPROV').readOnlyOnEdit = !row.DSALMOXREPROV;
						break;
					case 12:
						args.owner.field.widget.currentRow.DSLOCALCONSVND = '';
						args.owner.field.widget.getField('DSLOCALCONSVND').readOnly = !row.DSALMOXCONSVND;
						args.owner.field.widget.getField('DSLOCALCONSVND').readOnlyOnEdit = !row.DSALMOXCONSVND;
						break;
				}
			}
		}

	};

	// função responsável por remover o bloqueio dos campos de local que já estão
	// com o campo de almoxarifado preenchido ao carregar uma nova stripe
	this.lockBreaker = function(widget) {
		if (widget.currentRow) {
			var widgetControle = widget.widgets[0].widgets[0];
			var widgetPedidos = widget.widgets[1].widgets[0];
			var widgetControleQualidade = widget.widgets[2].widgets[0];
			var widgetGestaoVendas = widget.container.getWidget('GESTAODEVENDAS');

			if (!fullLocalLock) {
				//1
				if (widgetControle.getField('DSALMOXINSPR').value()) {
					widgetControle.getField('DSLOCALINSPR').readOnly = false;
					widgetControle.getField('DSLOCALINSPR').readOnlyOnEdit = false;
				}
				else {
					widgetControle.getField('DSLOCALINSPR').readOnly = true;
					widgetControle.getField('DSLOCALINSPR').readOnlyOnEdit = true;
				}
				//2
				if (widgetControle.getField('DSALMOXPRSEMACA').value()) {
					widgetControle.getField('DSLOCALPRSEMACA').readOnly = false;
					widgetControle.getField('DSLOCALPRSEMACA').readOnlyOnEdit = false;
				}
				else {
					widgetControle.getField('DSLOCALPRSEMACA').readOnly = true;
					widgetControle.getField('DSLOCALPRSEMACA').readOnlyOnEdit = true;
				}
				//3
				if (widgetControle.getField('DSALMOXINSPRPIL').value()) {
					widgetControle.getField('DSLOCALINSPRPIL').readOnly = false;
					widgetControle.getField('DSLOCALINSPRPIL').readOnlyOnEdit = false;
				}
				else {
					widgetControle.getField('DSLOCALINSPRPIL').readOnly = true;
					widgetControle.getField('DSLOCALINSPRPIL').readOnlyOnEdit = true;
				}
				//4
				if (widgetControle.getField('DSALPROD').value()) {
					widgetControle.getField('DSLOCPROD').readOnly = false;
					widgetControle.getField('DSLOCPROD').readOnlyOnEdit = false;
				}
				else {
					widgetControle.getField('DSLOCPROD').readOnly = true;
					widgetControle.getField('DSLOCPROD').readOnlyOnEdit = true;
				}
				//5
				if (widgetControle.getField('DSALPRODPIL').value()) {
					widgetControle.getField('DSLOCPRODPRIL').readOnly = false;
					widgetControle.getField('DSLOCPRODPRIL').readOnlyOnEdit = false;
				}
				else {
					widgetControle.getField('DSLOCPRODPRIL').readOnly = true;
					widgetControle.getField('DSLOCPRODPRIL').readOnlyOnEdit = true;
				}
				//6
				if (widgetControle.getField('DSALMOXPRACA').value()) {
					widgetControle.getField('DSLOCALPRACA').readOnly = false;
					widgetControle.getField('DSLOCALPRACA').readOnlyOnEdit = false;
				}
				else {
					widgetControle.getField('DSLOCALPRACA').readOnly = true;
					widgetControle.getField('DSLOCALPRACA').readOnlyOnEdit = true;
				}
				//7
				if (widgetPedidos.getField('DSALMOXPRCLI').value()) {
					widgetPedidos.getField('DSLOCALPRCLI').readOnly = false;
					widgetPedidos.getField('DSLOCALPRCLI').readOnlyOnEdit = false;
				}
				else {
					widgetPedidos.getField('DSLOCALPRCLI').readOnly = true;
					widgetPedidos.getField('DSLOCALPRCLI').readOnlyOnEdit = true;
				}
				//8
				if (widgetControleQualidade.getField('DSALMOXARIFE').value()) {
					widgetControleQualidade.getField('DSLOCALESTOQ').readOnly = false;
					widgetControleQualidade.getField('DSLOCALESTOQ').readOnlyOnEdit = false;
				}
				else {
					widgetControleQualidade.getField('DSLOCALESTOQ').readOnly = true;
					widgetControleQualidade.getField('DSLOCALESTOQ').readOnlyOnEdit = true;
				}
				//9
				if (widgetControleQualidade.getField('DSALMOXQUAMPPIL').value()) {
					widgetControleQualidade.getField('DSLOCALQUAMPPIL').readOnly = false;
					widgetControleQualidade.getField('DSLOCALQUAMPPIL').readOnlyOnEdit = false;
				}
				else {
					widgetControleQualidade.getField('DSLOCALQUAMPPIL').readOnly = true;
					widgetControleQualidade.getField('DSLOCALQUAMPPIL').readOnlyOnEdit = true;
				}
				//10
				if (widgetControleQualidade.getField('DSALMOXQUAR').value()) {
					widgetControleQualidade.getField('DSLOCALQUAR').readOnly = false;
					widgetControleQualidade.getField('DSLOCALQUAR').readOnlyOnEdit = false;
				}
				else {
					widgetControleQualidade.getField('DSLOCALQUAR').readOnly = true;
					widgetControleQualidade.getField('DSLOCALQUAR').readOnlyOnEdit = true;
				}

				if (widgetControleQualidade.getField('DSALMOXREPROV').value()) {
					widgetControleQualidade.getField('DSLOCALREPROV').readOnly = false;
					widgetControleQualidade.getField('DSLOCALREPROV').readOnlyOnEdit = false;
				}
				else {
					widgetControleQualidade.getField('DSLOCALREPROV').readOnly = true;
					widgetControleQualidade.getField('DSLOCALREPROV').readOnlyOnEdit = true;
				}
				//12
				if(widgetGestaoVendas.getField('DSALMOXCONSVND').value()){
					widgetGestaoVendas.getField('DSLOCALCONSVND').readOnly = false;
					widgetGestaoVendas.getField('DSLOCALCONSVND').readOnlyOnEdit = false;
				}
				else {
					widgetGestaoVendas.getField('DSLOCALCONSVND').readOnly = true;
					widgetGestaoVendas.getField('DSLOCALCONSVND').readOnlyOnEdit = true;
				}

				widgetControle.reload();
				widgetPedidos.reload();
				widgetControleQualidade.reload();
				widgetGestaoVendas.reload();
			}
		}
	};

	this.openPopupCadastro = function(widget) {
		var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICO');
		var filtroAplicadoRow = widget.appliedFilter.FILTER_ROW;
		widgetPopup.isVisible = true;
		widgetPopup.activate();
		widgetPopup.edit();
		this.blockAlmoxCadastro(widgetPopup);
		ScreenService.openPopup(widgetPopup).then(success => {
			widgetPopup.currentRow.CDFILIAL = filtroAplicadoRow.CDFILIAL;
			widgetPopup.currentRow.NMFILIAL = filtroAplicadoRow.NMFILIAL;
			this.filiProd(widgetPopup);
		});
	};

	this.blockAlmoxCadastro = function(widget) {
		widget.getField('DSALMOXINSPR').readOnly = true;
		widget.getField('DSALMOXINSPR').readOnlyOnEdit = true;
		//2
		widget.getField('DSALMOXPRSEMACA').readOnly = true;
		widget.getField('DSALMOXPRSEMACA').readOnlyOnEdit = true;
		//3
		widget.getField('DSALMOXINSPRPIL').readOnly = true;
		widget.getField('DSALMOXINSPRPIL').readOnlyOnEdit = true;
		//4
		widget.getField('DSALPROD').readOnly = true;
		widget.getField('DSALPROD').readOnlyOnEdit = true;
		//5
		widget.getField('DSALPRODPIL').readOnly = true;
		widget.getField('DSALPRODPIL').readOnlyOnEdit = true;
		//6
		widget.getField('DSALMOXPRACA').readOnly = true;
		widget.getField('DSALMOXPRACA').readOnlyOnEdit = true;
		//7
		widget.getField('DSALMOXPRCLI').readOnly = true;
		widget.getField('DSALMOXPRCLI').readOnlyOnEdit = true;
		//8
		widget.getField('DSALMOXARIFE').readOnly = true;
		widget.getField('DSALMOXARIFE').readOnlyOnEdit = true;
		//9
		widget.getField('DSALMOXQUAMPPIL').readOnly = true;
		widget.getField('DSALMOXQUAMPPIL').readOnlyOnEdit = true;
		//10
		widget.getField('DSALMOXQUAR').readOnly = true;
		widget.getField('DSALMOXQUAR').readOnlyOnEdit = true;

		//11
		widget.getField('DSALMOXREPROV').readOnly = true;
		widget.getField('DSALMOXREPROV').readOnlyOnEdit = true;
		
		//12
		widget.getField('DSALMOXCONSVND').readOnly = true;
		widget.getField('DSALMOXCONSVND').readOnlyOnEdit = true;
	};
	
	// concatenação de código para relatorio produto final
	this.getValueProdFin = function(){
		let filterValueProdFin = EstUtil.getFieldValue('P_CDPRODFIN','widgetProduto',true);
		
		if(filterValueProdFin){
			let concatString = filterValueProdFin.concat('zzzzzzzzzzzzzzzzzzzz');
			let newResult = concatString.substring(0,20);
			return newResult;
		}else{
			return 'zzzzzzzzzzzzzzzzzzzz';
		}
	};
	
	// verificacao de valores para produto inicial
	this.getValueProdIni = function() {
		let filterValueProdIni = EstUtil.getFieldValue('P_CDPRODINI', 'widgetProduto', true);
				
		if(filterValueProdIni) {
			return filterValueProdIni;
		} else {
			return '1';
		}
	};
	
	// Gera relatórios de produtos XML/PDF
	this.generateReportXmlPdf = function(type){
        let REPORT_JSON = "./json/containers/ger27000_local_de_estoque_por_produto.json";
        let widgetRelatorio = templateManager.container.getWidget('TABBEDRELATORIOS');
        let widgetProduto = templateManager.container.getWidget('widgetProduto');
        ScreenService.showLoader();
        ScreenService.openSwipe(widgetRelatorio).then((opened) => {
	        widgetRelatorio.reload().then(loaded => {
	            restEngine.requestMetaData(REPORT_JSON).then(function (reportMetaData) {
	                ZhReports.openReport(reportMetaData.data, widgetRelatorio, null, null, type);
	                setTimeout(() => {
        				ScreenService.goBack();
	                	ScreenService.hideLoader();
	                }, 1500);
	            });
	        });
        });
        widgetProduto.activate();
    };
	
	// atualizar os dados automaticamente ao abrir o relatório de produtos. 
	this.autoUpdateOnEnter = ()=>{
	let widgetRelatorios = templateManager.container.getWidget('TABBEDRELATORIOS');
		widgetRelatorios.reload();
	};
	
	this.saveCadastroAutomatico = function(widget) {
		var row = widget.currentRow;
		row.CDNVPRODUTO = General.getLevelByMask('CDPICTPROD', 1).length;
		if (widget.isValid()) {
			General.callRestEngine('est#/cadastroAutomaticoLocalProduto', 'Row', row).then(function(success) {
					var widgetActivate = templateManager.container.getWidget('widgetProduto');
					var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICO');
					widgetPopup.isVisible = false;
					widgetPopup.currentRow = {};
					ScreenService.closePopup(widgetPopup);
					widgetActivate.activate().then(activated => {
							widgetActivate.reload().then(reloaded => {
								if(fullLocalLock && fullAlmoxLockCad) {
									MessageService.showMessageByCode("CADASTRO_AUTOMATICO_SUCCESS_2");
								} else {
									MessageService.showMessageByCode("CADASTRO_AUTOMATICO_SUCCESS_1");
								}
						}).catch(errorReload => {
							ScreenService.showMessage(errorReload);
						});
					}).catch(errorActivate => {
						ScreenService.showMessage(errorActivate);
					});
				},
				function(callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				}
			);
		}
	};

	this.cancelarCadastroAutomaticoItem = function() {
		var widget = templateManager.container.getWidget('CADASTROAUTOMATICO');
		widget.currentRow = {};
		var widgetActivate = templateManager.container.getWidget('widgetProduto');
		widget.isVisible = false;
		ScreenService.closePopup(widget);
		widgetActivate.activate();
		widgetActivate.reload();
	};

	this.checkProductRange = function(field) {
		var currentRow = field.widget.currentRow;

		if (currentRow.P_CDPRODINI && currentRow.P_CDPRODFIN) {
			var compproduto = (currentRow.P_CDPRODFIN) ? currentRow.P_CDPRODFIN.replace(/[\.\-]/g, '') : null;

			if (!General.comparaPratoProduto(currentRow.P_CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
				currentRow[field.outData[field.descriptionField]] = null;
				currentRow[field.outData[field.valueField]] = null;

				ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
			}
		}
	};
	//-------------------------- funções CRUD ---------------
	//função default para editar
	this.edit = function(widget) {

		General.edit(widget);
		controlaStatusWidgets(widget.getParent().getParent(), widget.name, false, []);
		var gridProd = templateManager.container.getWidget("widgetProduto");
		cdProd = gridProd.currentRow.CDPRODUTO;
		nmProd = gridProd.currentRow.NMPRODUTO;
		widget.template = 'widget/form.html';
	};


	var controlaStatusWidgets = function(widgetPai, nomeWidgetAtual, status, ignoredWidgets) {
		var allWidgets = widgetPai.widgets;

		allWidgets.filter(widget => widget.name !== nomeWidgetAtual).forEach(widget => widget.enabled = status);

		if (widgetPai.name !== nomeWidgetAtual)
			widgetPai.enabled = status;

		if (Array.isArray(ignoredWidgets))
			allWidgets.filter(widget => ignoredWidgets.indexOf(widget.name) !== -1).forEach(widget => widget.enabled = !status);
	};

	//função default para cancelar uma edição
	this.cancelEdit = function(args) {
		args.owner.widget.template = 'widget/form-view.html';
		var widget = args.owner.widget;
		controlaStatusWidgets(widget.getParent().getParent(), widget.name, true, []);
		General.backOrCancel(args);
		args.owner.widget.list();
		args.owner.widget.reload();
	};

	//função default para salvar uma edição
	this.saveEdit = function(widget) {
		var gridProd = templateManager.container.getWidget("widgetProduto");

		General.saveCrud(widget).then(function(Succes) {
			widget.template = 'widget/form-view.html';
			widget.list();
			controlaStatusWidgets(widget.getParent().getParent(), widget.name, true, []);
			widget.reload();
		}.bind(this));
	};
	//--------------------------------------------------------
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Ger27000_LocalEstoqueProduto_Controller', Ger27000_LocalEstoqueProduto_Controller);
});
