var ProdTreeGroup = function(General, ZHPromise){
    /**
     * [getAllGroups Trata casos de seleção de grupos cuja grupo
     * ainda não foi carregado e possui filhos.]
     * @param  {[Array]} fieldTreeProd [Agrupamento de Produto]
     * @return {[Array]}    [Grupos e respectivas dependencias]
     */
    this.getAllGroups = function(fieldTreeProd){
        var deferred = ZHPromise.defer();
        var groups = [];
        var fullGroups = [];
        var selectedRows = fieldTreeProd.dataSource.getCheckedRows();
        selectedRows.forEach(function(pai){
            if (pai._hasChild){
                if (pai.hasOwnProperty('__processed')){
                    groups.push(pai.NRARVOREPROD);
                }else{
                    fullGroups.push(pai.NRARVOREPROD);
                }
            }else{
                groups.push(pai.NRARVOREPROD);
            }
        });
        var route = 'est#/getAllGroupsByParents';
        General.callRestEngine(route, 'Row', fullGroups)
            .then(function(response){
                var childrenoffullgroups = response.dataset.all_groups;
                 var allGroups = childrenoffullgroups.concat(groups);
                deferred.resolve(allGroups);
            })
            .catch(function(erro){
                deferred.reject(erro);
            });
        return deferred.promise;
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('ProdTreeGroup', ProdTreeGroup);
});