var Est57000_TransferenciaEstoque_Repository = function (restEngine) {

    this.buscaDataProcessamento = function(row) {
        return restEngine.post('est#/dataProcessamentoUnidade', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveNovaTransferencia = function(rows) {
        return restEngine.post('est#/saveNewTransferencia', {
            "requestType": "Row",
            "row": rows
        });
    };

    this.saveNovoProdutoTransferencia = function(row) {
        return restEngine.post('est#/saveNovoProdutoTransferencia', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveNovaTransferenciaComRequisicao = function(row) {
        return restEngine.post('est#/saveNewTransferenciaRequisicao', {
            "requestType": "Row",
            "row": row
        });
    };

    this.editProduto = function(row) {
        return restEngine.post('est#/editProdutoTransferencia', {
            "requestType": "Row",
            "row": row
        });
    };

    this.deleteProduto = function(row) {
        return restEngine.post('est#/deleteProdutoTransferencia', {
            "requestType": "Row",
            "row": row
        });
    };

    this.deleteTransferencia = function(row) {
        return restEngine.post('est#/deleteTransferencia', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.getAlmoxRequisicao = function(row) {
        return restEngine.post('est#/getAlmoxRequisicao', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.verificaEstoqueProduto = function(row) {
         var filtro = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": row.CDFILIMOVI
            },
            {
                "name": "P_CDPRODUTO",
                "operator": "=",
                "value": row.CDPRODUTO
            },
            {
                "name": "P_NRLOTEESTQ",
                "operator": "=",
                "value": row.NRLOTEESTQ
            },
            {
                "name": "P_NRSUBLOTE",
                "operator": "=",
                "value": row.NRSUBLOTE
            },
            {
                "name": "P_DTPOSICAO",
                "operator": "=",
                "value": row.DTLANCMOVI
            },
            {
                "name": "P_CDALMOXARIFE",
                "operator": "=",
                "value": row.CDALMOXARIFE
            },
            {
                "name": "P_CDLOCALESTOQ",
                "operator": "=",
                "value": row.CDLOCALESTOQ
            },
            {
                "name": "P_IDQUANTID",
                "operator": "=",
                "value": row.IDQUANTID
            }
        ];
        return restEngine.post('est#/lote_infCompl_almox', {
            "requestType": "FilterData",
            "filter": filtro
        });
    };
    
    this.buscaProdutosRequisicao = function(row) {
        var filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL
            },
            {
                "name": "NRREQUESTO",
                "operator": "=",
                "value": row.NRREQUESTO
            },
            {
                "name": "IDSTITREQU",
                "operator": "=",
                "value": 'A'
            }
        ];
        return restEngine.post('est#/itrequesto_itens_requisicao', {
            "requestType": "FilterData",
            "filter": filtro
        });
    };
    
    this.getCdtipocusto = function(cdfilial) {
        return restEngine.post('est#/crud/paramfilial', {
            "requestType": "FilterData",
            "filter": [{
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": cdfilial
                        }]
        });
    };
    
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('Est57000_TransferenciaEstoque_Repository', Est57000_TransferenciaEstoque_Repository);
});