var est53000_parametros_de_estoque_repository = function(restEngine) {
    var self = this;

    self.deleteAllRealizationDays = function(CDFILIAL) {
        return restEngine.post("est#/paramestoque_invrotativo_dias/remove", {
            "requestType": "FilterData",
            "filter": [
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: CDFILIAL
                }
            ]
        });
    };

    self.getDataForGeralWidget = function() {
        return restEngine.post("est#/paramestoque_geral", {
            "requestType": "FilterData",
            "filter": []
        });
    };

    self.getDataForProdutoField = function() {
        return restEngine.post("est#/paramestoque_produto_field", {
            "requestType": "FilterData",
            "filter": []
        });
    };

    self.getDataForProdutoWidget = function(CDALMOXARIFE, CDLOCALESTOQ, CDFILIAL) {
        return restEngine.post("est#/paramestoque_produto_widget", {
            "requestType": "FilterData",
            "filter": [
                {
                    name: "CDALMOXARIFE",
                    operator: "=",
                    value: CDALMOXARIFE
                },
                {
                    name: "CDLOCALESTOQ",
                    operator: "=",
                    value: CDLOCALESTOQ
                },
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: CDFILIAL
                }
            ]
        });
    };

    self.getDataForUnidadeWidget = function(CDFILIAL) {
        return restEngine.post("est#/paramestoque_unidade", {
            "requestType": "FilterData",
            "filter": [
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: CDFILIAL
                }
            ]
        });
    };

    self.saveProduct = function(row) {
        return restEngine.post("est#/paramestoque_produto/save", {
            "requestType": "Row",
            "row": row
        });
    };

    self.validateProduct = function(CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO, CDARVPROD, IDCURVAABC) {
        return restEngine.post("est#/paramestoque_produto_validation", {
            "requestType": "FilterData",
            "filter": [
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: CDFILIAL
                },
                {
                    name: "CDALMOXARIFE",
                    operator: "=",
                    value: CDALMOXARIFE
                },
                {
                    name: "CDLOCALESTOQ",
                    operator: "=",
                    value: CDLOCALESTOQ
                },
                {
                    name: "CDPRODUTO",
                    operator: "=",
                    value: CDPRODUTO
                },
                {
                    name: "CDARVPROD",
                    operator: "=",
                    value: CDARVPROD
                },
                {
                    name: "IDCURVAABC",
                    operator: "=",
                    value: IDCURVAABC
                }
            ]
        });
    };

    self.saveGeral = function(row) {
        return restEngine.post('est#/paramestoque_geral/save', {
            "requestType": "Row",
            "row": row
        });
    };

    self.saveUnidade = function(row) {
        return restEngine.post('est#/paramestoque_unidade/save', {
            "requestType": "Row",
            "row": row
        });
    };

    self.saveParametrosCurvaAbc = function(row) {
        return restEngine.post('est#/curvaAbc_parametros/save', {
            "requestType": "Row",
            "row": row
        });
    };

    self.deleteProdutoCurvaAbc = function(row) {
        return restEngine.post('est#/produtos_curvaAbc/remove', {
            "requestType": "Row",
            "row": row
        });
    };

};

Configuration(function (ContextRegister){
    ContextRegister.register('est53000_parametros_de_estoque_repository', est53000_parametros_de_estoque_repository);
});