var est53000_parametros_de_estoque_service = function(est53000_parametros_de_estoque_repository, ZHPromise) {
    var self = this;

    self.deleteAllRealizationDays = function(row) {
        var CDFILIAL = row.CDFILIAL;

        if(CDFILIAL)
            return est53000_parametros_de_estoque_repository.deleteAllRealizationDays(CDFILIAL);
        else {
            var promise = ZHPromise.defer();
            promise.reject('Erro Catastrófico! Erro na requisição da exclusão dos dias de realização do Inventário Rotativo!');

            return promise;
        }
    };

    self.getDataForGeralWidget = function() {
        return est53000_parametros_de_estoque_repository.getDataForGeralWidget().then(function(response) {
            var data = response.dataset.paramestoque_geral;

            return data;
        });
    };

    self.getDataForProdutoField = function() {
        return est53000_parametros_de_estoque_repository.getDataForProdutoField().then(function(response) {
            var data = response.dataset.paramestoque_produto_field;

            return data;
        });
    };

    self.validateProduct = function(row) {
        var CDFILIAL     = row.CDFILIAL;
        var CDALMOXARIFE = (row.CDALMOXARIFE)? row.CDALMOXARIFE : ' ';
        var CDLOCALESTOQ = (row.CDLOCALESTOQ)? row.CDLOCALESTOQ : ' ';
        var CDPRODUTO    = row.CDPRODUTO;
        var CDARVPROD    = row.CDARVPROD;
        var IDCURVAABC   = row.IDCURVAABC;

        return est53000_parametros_de_estoque_repository.validateProduct(CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO, CDARVPROD, IDCURVAABC).then(function(response) {
            var isValid = response.dataset.paramestoque_produto_validation[0];

            return isValid;
        });
    };

    self.saveProduct = function(row) {
        row.CDALMOXARIFE = (row.CDALMOXARIFE)? row.CDALMOXARIFE : ' ';
        row.CDLOCALESTOQ = (row.CDLOCALESTOQ)? row.CDLOCALESTOQ : ' ';

        return est53000_parametros_de_estoque_repository.saveProduct(row);
    };

    self.getDataForProdutoWidget = function(row) {
        var CDALMOXARIFE = (row.CDALMOXARIFE)? row.CDALMOXARIFE : ' ';
        var CDLOCALESTOQ = (row.CDLOCALESTOQ)? row.CDLOCALESTOQ : ' ';
        var CDFILIAL     = row.CDFILIAL;

        return est53000_parametros_de_estoque_repository.getDataForProdutoWidget(CDALMOXARIFE, CDLOCALESTOQ, CDFILIAL).then(function(response) {
            var data = response.dataset.paramestoque_produto_widget;

            return data;
        });
    };

    self.getDataForUnidadeWidget = function(row) {
        var promise = ZHPromise.defer();
        var CDFILIAL = row.CDFILIAL;

        if(CDFILIAL)
            est53000_parametros_de_estoque_repository.getDataForUnidadeWidget(CDFILIAL).then(function(response) {
                var data = response.dataset.paramestoque_unidade;

                data.CDFILIAL     = CDFILIAL;
                data.NMRAZSOCFILI = row.NMRAZSOCFILI;
                data.NMFILIAL = row.NMFILIAL;

                promise.resolve(data);
            }, function(error) {promise.reject(error);});
        else
            promise.resolve({});

        return promise;
    };

    self.saveGeral = function(row){
        return est53000_parametros_de_estoque_repository.saveGeral(row);
    };

    self.saveUnidade = function(row){
        return est53000_parametros_de_estoque_repository.saveUnidade(row);
    };

    self.saveParametrosCurvaAbc = function(row){
        return est53000_parametros_de_estoque_repository.saveParametrosCurvaAbc(row);
    };

    self.deleteProdutoCurvaAbc = function(row){
        return est53000_parametros_de_estoque_repository.deleteProdutoCurvaAbc(row);
    };


    self.concatenaCampoParamfilial = function(row){
        var campo = row.IDBLOQESTNEG;
        var campoCompleto = row.DSPARFILFIS;
        if(campo){
            if (!campoCompleto) {
                campoCompleto = "   " + campo;
            }else {
                switch(campoCompleto.length) {
                    case 1:
                        campoCompleto= campoCompleto+"  "+campo;
                        break;
                    case 2:
                        campoCompleto = campoCompleto+" "+campo;
                        break;
                    case 3:
                        campoCompleto = campoCompleto+campo;
                        break;
                    default:
                        var parteinicial = campoCompleto.substr(0, 3);
                        var partefinal = campoCompleto.substr(4);
                        campoCompleto = parteinicial + campo + partefinal;
                        break;
                }
            }
        }
        return campoCompleto;
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('est53000_parametros_de_estoque_service', est53000_parametros_de_estoque_service);
});