var ValidacoesEstoque_Repository = function (localStorageEngine, restEngine) {
    var row = {};

    this.validaDataLancamento = function (filial, dtLancamento, operacao, sistema, dtEmissao) {

        row.CDFILIAL = filial;
        row.DTLANCTOEST = dtLancamento;
        row.OPERACAO = operacao;
        row.IDSISTEMA = sistema;
        row.DTEMISSAO = dtEmissao;

        return restEngine.post('est#/validacoes_estoque/data_lancamento', {
            "requestType": "Row",
            "row": row
        });
    };

    /* **************************************************
     * Função que requisita a execução da atualização de
     * estoque. Para maiores informações, favor verificar
     * a função de mesmo nome no Service de validações de
     * estoque.
     *
     * @param string cdfilial
     * @param string nrlancestq
     * @param boolean verifyIrregularities
     * @param boolean abortAtIrregularities
     * @param Array seqItemCodes
     *
     * @return Promise
     */
    this.atualizaEstoque = function (cdfilial, nrlancestq, verifyIrregularities, abortAtIrregularities, seqItemCodes, boolConsolidateToStock) {
        //sets row values
        row.CDFILIAL = cdfilial;
        row.NRLANCESTQ = nrlancestq;
        row.IDVERIRREG = verifyIrregularities;
        row.IDABRIRREG = abortAtIrregularities;
        row.SEQITEMS = seqItemCodes;
        row.CONSOLIDATE = boolConsolidateToStock;

        //sends a request to the backend
        return restEngine.post('est#/validacoes_estoque/atualiza_estoque', {
            "requestType": "Row",
            "row": row
        });
    };

    this.zeraInventario = function (filial, nrLancamento, idordemclc, boolConsolidateToStock) {

        row.CDFILIAL = filial;
        row.NRLANCAMENTO = nrLancamento;
        row.IDORDEMCLC = idordemclc;
        row.CONSOLIDATE = boolConsolidateToStock;
        
        //sends a request to the backend
        return restEngine.post('est#/validacoes_estoque/zera_inventario', {
            "requestType": "Row",
            "row": row
        });
    };

    this.consultaCustoQuantidadeProduto = function (
        filial, produto, dtLancamento, tipoCusto, almoxarifado, localEstoque, lote, subLote
    )
    {
        row.CDFILIAL = filial;
        row.CDTIPOCUST = tipoCusto;
        row.CDPRODUTO = produto;
        row.CDALMOXARIFE = almoxarifado;
        row.CDLOCALESTOQ = localEstoque;
        row.NRLOTE = lote;
        row.NRSUBLOTE = subLote;
        row.DTLANCAMENTO = dtLancamento;

        return restEngine.post('est#/validacoes_estoque/consulta_custo', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.getPosicaoDeEstoquePorProduto = function(filter) {
        return restEngine.post('est_lancamentos#/retirada_posestdia', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('ValidacoesEstoque_Repository', ValidacoesEstoque_Repository);
});